#!/usr/bin/env perl
use strict;
use lib $ENV{ 'MAIN_CONF'}  ;
use main_config ;
my %commands = () ;

if ( @ARGV <= 0 ) { push ( @{$commands{'help'}}, ' ' ) ; } 
else { (%commands) = main_config::get_commands ( @ARGV ) ; }

my $conf_file ;
if ( -f "main_config.data" )
{    $conf_file = "main_config.data" ; }
else
{    $conf_file = join ('', $ENV{"MAIN_CONF"}, "main_config.data" ) ; }

my %my_main = main_config::read_main_config_file ( $conf_file ) ; 

#print " map kicked random: {", @{$my_main{"MAP_KICK_SERIES"}}, "}\n" ;
#####################################################################

if ( !exists($my_main{"IO_TASK"}  ) )       { push ( @{$my_main{"IO_TASK"}}  , "READ" ) ; }
if ( !exists($my_main{"IO_OBJECT"}  ) )       { push ( @{$my_main{"IO_OBJECT"}}  , "ATOMS" ) ; }
if ( !exists($my_main{"IO_FILE"}  ) )    { push ( @{$my_main{"IO_FILE"}}  , "model.pdb" ) ; }
if ( !exists($my_main{"IO_SELECTION"}  ) )  { push ( @{$my_main{"IO_SELECTION"}}  , "active" ) ; }


######################################################
#print " map after setup kicked random: {", @{$my_main{"MAP_KICK_SERIES"}}, "}\n" ;

my $MACRO_FILE = "io_data.cmds" ;
my $PROC_ERROR = "FALSE" ;
my $doit = "FALSE" ;
my $keyword ; 
foreach $keyword ( sort keys (%commands) ) 
{
#    print "option >$keyword<\n" ; 
    if ( $keyword eq 'h' || substr($keyword, 0,4) eq "help" ) { goto HELP }
    if ( $keyword eq 'f' || substr($keyword, 0,4) eq "file" ) { goto FILE }
    if ( $keyword eq 't' || substr($keyword, 0,4) eq "task" ) { goto TASK }
    if ( $keyword eq 'o' || substr($keyword, 0,6) eq "object" ) { goto OBJECT }
    if ( $keyword eq 's' || substr($keyword, 0,9) eq "selection" ) { goto SELECTION }

    if ( substr($keyword, 0,4) eq "doit" ) { $doit = "TRUE" ; next ; }
    print "unknown option >$keyword<\n" ; $PROC_ERROR = "TRUE" ;

  HELP:
    print << "END_OF_TEXT" ;
-h|--help)        prints this message with available options and their current status 
-t|--task)        task to do  [READ/WRITE] [@{$my_main{"IO_TASK"}}]
-f|--file)        file name [@{$my_main{"IO_FILE"}}]
-o|--object)      object for io [ATOMS/CELL/MAP/REFLECTION/SURFACE/SYMMETRY] [@{$my_main{"IO_OBJECT"}}]
-s|--selection)   selection [@{$my_main{"IO_SELECTION"}}]
   --doit)        create the macro
END_OF_TEXT
    exit ;

  TASK:       @{$my_main{"IO_TASK"}} = shift ( @{$commands{$keyword}} ) ; next ;
  FILE:       @{$my_main{"IO_FILE"}} = shift ( @{$commands{$keyword}} ) ; next ;
  OBJECT:     @{$my_main{"IO_OBJECT"}} = shift ( @{$commands{$keyword}} ) ; next ;
  SELECTION:  @{$my_main{"IO_SELECTION"}} = join (" ", @{$commands{$keyword}} ) ; next ;
}

if ( $PROC_ERROR eq "TRUE" ) { exit ; }

#######################################

$conf_file = "main_config.data" ; 
main_config::write_main_config_file ( $conf_file, %my_main ) ; 

###  . ${MAIN_CONF}main_config.data.save.sh

if ( $doit eq "FALSE" )  { exit ; }

######################################
exit ;
print "creating \"$MACRO_FILE\" \n" ;
if ( -f $MACRO_FILE ) 
{ 
    my $back = join ('', $MACRO_FILE, ".old" ) ; 
    system ( "mv  $MACRO_FILE $back" ) ; 
}


my @my_lines = () ;

my $IO_FILE ; 
my $MY_SELECTION ; 


open ( MACRO,  "> $MACRO_FILE" ) || die "FILE OPEN ERROR: >$MACRO_FILE< \n" ;

$IO_FILE = ${$my_main{"IO_FILE"}}[0] ;
$MY_SELECTION = ${$my_main{"IO_SELECTION"}}[0] ; 

# tasks


if ( ${$my_main{"IO_OBJECT"}}[0] eq "SURFACE" )
{
if ( uc(${$my_main{"IO_TASK"}}[0]) eq "WRITE" )
{
print MACRO << "END_OF_TEXT" ;
write over file $IO_FILE \\
sele $MY_SELECTION end \\
point surface 3net main \\
first sele $MY_SELECTION end
END_OF_TEXT
}
else
{
print MACRO << "END_OF_TEXT" ;
read file $IO_FILE \\
point main first sele $MY_SELECTION end

END_OF_TEXT
}
}
close (MACRO ) ;
exit ;
