package create_pury ;
use Math::Trig;

BEGIN 
{
    print("create pury.pm lib is here\n");
}

sub get_commands
{
    my $key = "" ;
    my $word ;
    my %c_line = () ;
    my @arg_char = () ;
    foreach $word ( @_ )
    {
	@arg_char = split( '', $word ) ;
#	print "word: $word \n" ; 
	if ( length($word) <= 0 ) { next ; }
	if ( $word !~ m"[a-zA-F]" ) { } #print "word: $word is a number\n" ; }
	else 
	{ 
#	    print "word: $word is a NON-number\n" ; 

	    if ( $arg_char[0] eq '-' ) 
	    {
		if ( $arg_char[1] eq "-" ) 
		{
		    my $num = scalar(@arg_char) - 1;
		    $key = join ( "", @arg_char[2 .. $num] );
		    push ( @{$c_line{$key}}, ' ' ) ; 
		}
		else
		{
		    $key = $arg_char[1] ; 
		    push ( @{$c_line{$key}}, ' ' ) ; 
		}
		next ;
	    }
	}

	if ( $key ne '' ) 
	{ 
	    $key = lc ( $key ) ; 
#	print "$key: \n" ;
	    my $tmp = join ( '', @{$c_line{$key}} ) ; 
	    if ( $tmp eq ' ' ) { delete $c_line{$key} ; }
	    push ( @{$c_line{$key}}, $word ); 
	}
    }
    return ( %c_line ) ;
}

sub is_organic_atom {

#    my $string = join ( "+", @_ ) ;
#    print "is_organic_atom> |$string|\n" ;
    my $class = shift;
    my $c1 = substr ($class, 0, 1);
    my $c2 = substr ($class, 1, 1);
    my $c3 = substr ($class, 2, 1);
    my $c4 = substr ($class, 3, 1);
#    print "\t$class CC> $c1$c2\n";

    my $el;
    if ($c2 =~ /[a-z]/) {
	$el = $c1.$c2;
    } else {
	$el = $c1;
    }
    my @elements = qw (C
		       H
		       N
		       O
		       P
		       S
		       Cl
		       Br
		       F
		       I);
    my $cool = 0;
    
    foreach (@elements) {
	if ($el eq $_) {
	    $cool = 1;
	}
    }
    return $cool;
}

sub check_class {

    my $class = shift;
    my $out = 0;
    
    if ($class =~ /[A-Z][A-Za-z0-9\_\*\-\#\%\<]{3}/) {
	$out = 1;
    }
    
    return $out;
}

sub calculate_bond_params
{
    my $ref = shift ;
    my @data_list = @{$ref} ;
 #   my $n = $#data_list ;
    my $n = scalar (@data_list);

    my $d ;

#    print " create_pury.pm> atan", atan(0.3333), "\n" ;

    my $s_t2 = 0 ;
    my $s_t = 0 ;
    my $rmsa = 0;

    foreach $d ( @data_list )
    {
	$s_t = $s_t + $d ;
	$s_t2 = $s_t2 + $d**2 ;
    }

    $aver = $s_t / $n ;
    $rmsa = abs( $s_t2 - $s_t / $n * $s_t) ;
    if ( $n > 1 ) { $rmsa = $rmsa / ( $n - 1 ) ; }
    $sig = sqrt ( $rmsa ) ;

    
    my $C1 = 0.592;
    my $e = 300 ;

    if ($sig < 0.001) { $sig = 0.001; }
    if ($n > 2) 
    {
	if ($sig > 0.000) 
	{
	    $e = $C1/($sig * $sig);
	    if ($e > 5000) { $e = 5000; }
	} 
	else { $e = 2000; }	 
    } 
    else 
    {
	if ($sig > 0.000) 
	{
	    $e = $C1/($sig * $sig);
	    if ($e > 5000) { $e = 5000; }
	} 
	else { $e = 500; }	 
    }

#    print "\n ----> average $aver $sig $n $e \n\n" ;
    return ( $aver, $sig, $e ) ;
}

sub calculate_angle_params
{
    my $ref = shift ;
    my @data_list = @{$ref} ;
 #   my $n = $#data_list ;
    my $n = scalar (@data_list);

    my $d ;

#    print " create_pury.pm> atan", atan(0.3333), "\n" ;

    my $s_t2 = 0 ;
    my $s_t = 0 ;
    my $rmsa = 0;

    foreach $d ( @data_list )
    {
	$s_t = $s_t + $d ;
	$s_t2 = $s_t2 + $d**2 ;
    }

    $aver = $s_t / $n ;
    $rmsa = abs( $s_t2 - $s_t / $n * $s_t) ;
    if ( $n > 1 ) { $rmsa = $rmsa / ( $n - 1 ) ; }
    $sig = sqrt ( $rmsa ) ;

    
    my $C1 = 1943.4248;
    my $e = 100 ;

    if ($sig < 0.001) { $sig = 0.001; }
    if ($n > 2) 
    {
	if ($sig > 0.000) 
	{
	    $e = $C1/($sig * $sig);
	    if ($e > 2000) { $e = 2000; }
	} 
	else { $e = 2000; }	 
    } 
    else 
    {
	if ($sig > 0.000) 
	{
	    $e = $C1/($sig * $sig);
	    if ($e > 2000) { $e = 2000; }
	} 
	else { $e = 100; }	 
    }

#    print "\n ----> average $aver $sig $n $e \n\n" ;
    return ( $aver, $sig, $e ) ;
}

sub calculate_dihed_params
{
    my $ref = shift ;
    my @data_list = @{$ref} ;
 #   my $n = $#data_list ;
    my $n = scalar (@data_list);

    my $m_period = 9 ;
    my @a_cos = () ;
    my @a_sin = () ;
    my $d ;
    my $k ;
    my $rphase ;

#    print " create_pury.pm> atan", atan(0.3333), "\n" ;

    for ($k = 0; $k < $m_period; $k++ )
    {
	$a_cos[$k] = 0 ;
	$a_sin[$k] = 0 ;
    }

    foreach $d ( @data_list )
    {
	for ($k = 1; $k < $m_period; $k++ )
	{
	    $rphase = deg2rad( $k*$d ) ;
	    $a_cos[$k] = $a_cos[$k] + cos ($rphase) ;
	    $a_sin[$k] = $a_sin[$k] + sin ($rphase) ;
#	    print $k, ") ", $d, "> ", $a_cos[$k],  " + ", $a_sin[$k], " = ", $a_cos[$k]**2 + $a_sin[$k]**2,"\n" ;
	}
    }

    my @a_sq = () ;
    my @t_sc = () ;
    my %p_seq = () ;
    my $rmax = 0 ;
    for ($k = 1; $k < $m_period; $k++ )
    {
	$a_sq[$k-1] = $a_cos[$k]**2 + $a_sin[$k]**2 ;
#	$t_cs[$k-1] = $a_sin[$k] / $a_sin[$k] ;
	if ( $a_sq[$k-1] > $rmax ) 
	{ 
	    $rmax =  $a_sq[$k-1] ; 
	}
    }
#    print "dihed in:", join (" ", @a_sq), "\n" ;

#    print " rmax : $rmax \n" ;
    
    $k = 0 ;
    for ($k = 0; $k < $m_period-1; $k++ )
    {
#	print " befor> $k: ", $a_sq[$k], " ", $rmax, "\n" ;
#	$a_sq[$k] = $a_sq[$k] / $rmax ;
#	print " after> $k: ", $a_sq[$k], " ", $rmax, "\n" ;
	my $key = $a_sq[$k] ;
	$p_seq{$key} = $k ;
    }

    
#    print "dihed s:", join (" ", @a_sin), "\n" ;
#    print "dihed c:", join (" ", @a_cos), "\n" ;
#    print "dihed tn:", join (" ", @t_cs), "\n" ;
#    print "dihed sq:", join (" ", @a_sq), "\n" ;
    
    my @list ;
    foreach ( sort {$b <=> $a}  keys %p_seq )
    {
	$d = $p_seq{$_} ;
	push ( @list, $d) ;
    }
#    print "list:", join(" ", @list ), "\n" ;
    
    my $aver = 0 ;
    my $sig = 1. ;
    my $p = $list[0] + 1;
    if ( $#list > 0 )
    {
	if ( $list[0] > $list[1] )
	{
	    if ( $a_sq[$list[1]]/$rmax > 0.97 ) { $p = $list[1]+1 ; }
	}
#    printf " %d sin %6f cos %6f \n", $p, $a_sin[$p], $a_cos[$p] ;
	if ( $p == 1 )
	{
	    if ( abs($a_sin[$p-1]) <= 0.001 && abs($a_cos[$p-1]) <= 0.001 )
	    { $aver = 0 ; }
	    else
	    {
		$aver = ran2deg(atan2 ( $a_sin[$p-1], $a_cos[$p-1]))  ;
#	    $aver = atan ( abs( $a_sin[$p-1] / $a_cos[$p-1])  ) / 3.1415 * 180. ;
	    }
	}
	else
	{
#	$aver = rad2deg(atan ( abs( $a_sin[$p-1] / $a_cos[$p-1])  ) / $p) / 3.1415 * 180. ;
#	$aver = rad2deg(atan ( abs( $a_sin[$p-1] / $a_cos[$p-1])  ) / $p) ;
	    $aver = rad2deg(atan2 ( $a_sin[$p-1], $a_cos[$p-1]))  / $p;
#	print "abs: tan> ", abs( $a_sin[$p-1] / $a_cos[$p-1]) , "\n" ;
	}
    }
    else
    {
	$aver = rad2deg(atan2 ( $a_sin[$p-1], $a_cos[$p-1]));
	$p = 1 ;
    }
    my $t ;
    my $s_t2 ;
    my $s_t ;
    my $m ; my $mm ;
    my $rsum = 0;
    my $pr= 360.0 / $p ;
    if ( $aver < 0.0 ) { $aver = $aver + $pr ; }

    foreach $d ( @data_list )
    {
	$t = ( $aver -$d + 360.0 ) ;
	$m = int($t / $pr) ;
	$s_t1 =  $t - $m * $pr ;
	$s_t2 =  $t - ($m+1) * $pr ;
#	print " 1> $s_t1 $s_t2\n" ;
	$mm = $m ;
	if ( abs($s_t1) > abs($s_t2) )
	{
	    $s_t1 = $s_t2 ;
	    $mm = $m+1 ;
	}
	$s_t2 =  $t - ($m-1) * $pr ;
	if ( abs($s_t1) > abs($s_t2) )
	{
#	    print " 2> $s_t1 $s_t2\n" ;
	    $s_t1 = $s_t2 ;
	    $mm = $m-1 ;
	}
	$s_t = $t - $mm * $pr ;
	$rsum = $rsum + $s_t**2 ;
#	print "d: $d t: $t m: $m $mm st: $s_t stf2: $s_t2\n";
    }

    $sig = sqrt ( $rsum / $n ) ;
#    print "\n ----> period $p  average $aver $sig $n \n\n" ;
    my $A1 = 500 ;
    if ( $p == 1 ) { $A1 = 300 ; }
    if ( $p == 2 ) { $A1 = 200 ; }
    if ( $p == 3 ) { $A1 = 20 ; }
    if ( $p == 4 ) { $A1 = 20 ; }
    if ( $p == 5 ) { $A1 = 20 ; }
    if ( $p == 6 ) { $A1 = 10 ; }
    if ( $p == 7 ) { $A1 = 10 ; }
    if ( $p == 8 ) { $A1 = 10 ; }
    if ( $p == 9 ) { $A1 = 10 ; }

    my $e ;
    if ( $sig <= 0.0 ) { $sig = 0.01 ; }
    $e = $A1 / ($sig**2);
    if ( $e > 2000 ) { $e = 2000 ; } 
    if ( $n <= 1 ) { $e = 1 ; } 
    return ( $aver, $sig, $p, $e ) ;
}

sub calculate_impro_params
{
    my $ref = shift ;
    my @data_list = @{$ref} ;
 #   my $n = $#data_list ;
    my $n = scalar (@data_list);

    my $d ;

#    print " create_pury.pm> atan", atan(0.3333), "\n" ;

    my $s_t2 = 0 ;
    my $s_t = 0 ;
    my $rmsa = 0;

    foreach $d ( @data_list )
    {
	$s_t = $s_t + $d ;
	$s_t2 = $s_t2 + $d**2 ;
    }

    $aver = $s_t / $n ;
    $rmsa = abs( $s_t2 - $s_t / $n * $s_t) ;
    if ( $n > 1 ) { $rmsa = $rmsa / ( $n - 1 ) ; }
    $sig = sqrt ( $rmsa ) ;

    
    my $C1 = 1000;
    my $e = 100 ;

    if ($sig < 0.001) { $sig = 0.001; }
    if ($n > 2) 
    {
	if ($sig > 0.000) 
	{
	    $e = $C1 / abs($sig) ;
	    if ($e > 2000) { $e = 2000; }
	    if ($e < 50) { $e = 50; }
	} 
	else { $e = 100; }	 
    } 
    else 
    {
	if ($sig > 0.000) 
	{
	    $e = $C1 / abs($sig) ;
	    if ($e > 2000) { $e = 2000; }
	    if ($e < 50) { $e = 50; }
	} 
	else { $e = 100; }	 
    }

#    print "\n ----> average $aver $sig $n $e \n\n" ;
    return ( $aver, $sig, $e ) ;
}

1;
