#!/usr/bin/env perl
use strict;
use lib $ENV{ 'MAIN_CONF'}  ;
use main_config ;
my %commands = () ;

if ( @ARGV <= 0 ) { push ( @{$commands{'help'}}, ' ' ) ; } 
else { (%commands) = main_config::get_commands ( @ARGV ) ; }

######################################################

my $conf_file ;
if ( -f "main_config.data" )
{    $conf_file = "main_config.data" ; }
else
{    $conf_file = join ('', $ENV{"MAIN_CONF"}, "main_config.data" ) ; }

my %my_main = main_config::read_main_config_file ( $conf_file ) ; 

#####################################################################

if ( !exists($my_main{"VALIDATION_XML_FILE"} ) ) { push ( @{$my_main{"VALIDATION_XML_FILE"}}, "validate.xml" ) };
if ( !exists($my_main{"VALIDATION_FIELD"} ) ) { push ( @{$my_main{"VALIDATION_FIELD"}}, "RAMA" ) };
if ( !exists($my_main{"VALIDATION_FORM"} ) ) { push ( @{$my_main{"VALIDATION_FORM"}}, "LIST" ) };

#####################################################################

my $MACRO_FILE = "center_next.com" ;
my $MACRO_FILE_COLOR = "validation_colors.com" ;
my $XML_FILE =  $my_main{"VALIDATION_FILE"}[0] ;
my $TOP_LIST = "-1" ;
my $TASK = "NONE" ;
my $CENTER_BY = "OTHER" ;
my $CUT_OFF = 0 ;
my $FIELD = "AVERAGE" ;
my $FORM =  $my_main{"VALIDATION_FORM"}[0] ;
my $PROC_ERROR = "FALSE" ;
my $doit = "FALSE" ;

my $keyword ; 
foreach $keyword ( sort keys (%commands) ) 
{
    if ( $keyword eq 'h' || substr($keyword, 0,4) eq "help" ) { goto HELP }
    if ( $keyword eq 'o' || substr($keyword, 0,6) eq "output" ) { goto OUTPUT }
    if ( $keyword eq 'i' || substr($keyword, 0,5) eq "input" ) { goto INPUT }
    if ( $keyword eq 'c' || substr($keyword, 0,5) eq "color" ) { goto COLOR }
    if ( $keyword eq 'f' || substr($keyword, 0,5) eq "field" ) { goto FIELD }
    if ( $keyword eq 'r' || substr($keyword, 0,4) eq "form" ) { goto FORM }
    if ( $keyword eq 't' || substr($keyword, 0,3) eq "top" ) { goto TOP }
    if ( substr($keyword, 0,4) eq "doit" ) { $doit = "TRUE" ; next ; }
     print "unknown option >$keyword<\n" ; $PROC_ERROR = "TRUE" ;

#    if ( $keyword eq 'k' || substr($keyword, 0,4) eq "task" ) { goto TASK }
#  -k|--task)    task [NONE/MINIMIZE/FIT_SIDE/AUTO_FIT/PICK_ATOM/MY_TASK] [$TASK]
HELP:
    print << "END_OF_TEXT" ;
  -h|--help)    prints this message with available options and current status 
  -o|--output)  set file name of the created macro [$MACRO_FILE]
  -c|--color)   set color file name of the created macro [$MACRO_FILE_COLOR]
  -i|--input)   input xml validation file [@{$my_main{"VALIDATION_XML_FILE"}}]
  -f|--field)   field [BOND/ANGLE/ROTA/RAMA/CLASH/SYMM/FLIP] [@{$my_main{"VALIDATION_FIELD"}}]
  -r|--form)    form [LIST/COLOR_CODE] [$FORM]
  -t|--top)     top [$TOP_LIST]
     --doit)    create the macro
END_OF_TEXT
    exit;

OUTPUT: $MACRO_FILE = shift ( @{$commands{$keyword}} ) ; next ;
INPUT: @{$my_main{"VALIDATION_XML_FILE"}} = shift ( @{$commands{$keyword}} ) ; next ;
COLOR: $MACRO_FILE_COLOR = shift ( @{$commands{$keyword}} ) ; next ;
FIELD: @{$my_main{"VALIDATION_FIELD"}} = shift ( @{$commands{$keyword}} ) ; next ;
FORM:  @{$my_main{"VALIDATION_FORM"}} = shift ( @{$commands{$keyword}} ) ; next ;
TOP: $TOP_LIST = shift ( @{$commands{$keyword}} ) ; next ;
TASK: $TASK = shift ( @{$commands{$keyword}} ) ; next ;
CENTER_BY: $CENTER_BY = shift ( @{$commands{$keyword}} ) ; next ;
}

#print " 00 --------------===============++++++++++++++++++++=============----------\n" ;

if ( $PROC_ERROR eq "TRUE" ) { exit ; }

#######################################

$conf_file = "main_config.data" ; 
main_config::write_main_config_file ( $conf_file, %my_main ) ; 



#######################################
my $XML_FILE = $my_main{"VALIDATION_XML_FILE"}[0] ;
my $FIELD = $my_main{"VALIDATION_FIELD"}[0] ;
my $FORM = $my_main{"VALIDATION_FORM"}[0] ;

my @xml_list = read_xml_file ( $XML_FILE ) ;

if ( $doit eq "FALSE" )  { exit ; }

#print "iii:", ${$ii}, "\n" ;
#print @xml_list ;

#my @xml_listss = @{$ref_xml} ;

#print " --------------===============++++++++++++++++++++=============----------\n" ;


if ( $doit eq "FALSE" )  { exit ; }

my $item ;
#my $item = pop ( @xml_list )
#my %list = () ;
#%list = %{$item} ;
#print %list ;


my %lookup = () ;
$lookup{"rama"} = "ModelledSubgroup" ;
$lookup{"rota"} = "ModelledSubgroup" ;
$lookup{"bond"} = "bond-outlier" ;
$lookup{"angle"} = "angle-outlier" ;
$lookup{"clash"} = "clash" ;
$lookup{"symm"} = "symm-clash" ;
$lookup{"flip"} = "ModelledSubgroup" ;

my $seq_ID  ;
my $res_num ;
my $res_name ;
my $chain ;
my $model ;
#print " -------------------------   ==============  form: $FORM\n" ;
if ( $FORM eq "LIST" )
{ 
    validation_list () ;
}
elsif ( $FORM eq "COLOR_CODE" )
{
    validation_color_code () ;
}

exit ;

sub validation_list
{

my $RAMA_NN = 0 ;
open ( MACRO,  "> $MACRO_FILE" ) || die "FILE OPEN ERROR: >$MACRO_FILE< \n" ;

my $my_field = $lookup{ lc($FIELD) } ;
foreach my $item ( @xml_list )
{
#    print "my keys: $_ $item->{$_}\n", for keys %$item ;
#    print "my keys: $_ \n", for keys %$item ;

#print "--item->", $item, "\n" ;


    if ( !exists( $item->{"ModelledSubgroup"} ) ) { next ; }

#    print "my keys: $_ $item->{$_}\n", for keys %$item ;

    $seq_ID =  $item->{"ModelledSubgroup"}{"seq"} ; 
#    print " top list> seq ID : >$seq_ID< \n" ;
    my @chrs = split("",$seq_ID) ; # =~ s/\//g ;
    if ( $chrs[$#chrs] eq '/' ) { pop @chrs ; }
    $seq_ID = join("", @chrs ) ;
    print " ... list> seq ID : >", $seq_ID, "< \n" ;
    $res_num =  $item->{"ModelledSubgroup"}{"resnum"} ;
    $res_name =  $item->{"ModelledSubgroup"}{"resname"} ;
    $chain =  $item->{"ModelledSubgroup"}{"chain"} ;
    $model =  $item->{"ModelledSubgroup"}{"model"} ;
    
#    print " model data:> $seq_ID, $res_num, $res_name, $chain, $model, <:\n" ;
    if ( $FIELD eq "RAMA" )
    {
	my $value =  $item->{$my_field}{"rama"} ;
	if ( $value eq "OUTLIER" )
	{
#	print ": rama, seq : ", $item->{$my_field}{"rama"}, " ", $seq_ID, "\n" ;
	    $RAMA_NN++ ;
	    print ": $RAMA_NN : rama outlier seq  $seq_ID $res_name $chain \n" ;
#	    if ( $RAMA_NN == 0 ) { print MACRO "<MAIN_CMDS_NEW:ramachan_modi.cmds \n" ; }
	    print MACRO << "END_OF_TEXT" ;

image cent sele seq $seq_ID .a atom name CA end
image hist center
!<MAIN_CMDS_NEW:ramachan_modi.cmds 
!<MAIN_CMDS_NEW:ramachan_modi.cmds 
key active sele by resi neigh \$1 10 end 
key passive sele by bond by resi active end 
return

END_OF_TEXT
	}
    }
    elsif ( $FIELD eq "ROTA" )
    {
	my $value =  $item->{$my_field}{"rota"} ;
	if ( $value eq "OUTLIER" )
	{
	print ": rota, seq : ", $item->{"rota"}, "<->", $seq_ID, "<>", $value, "\n" ;
	    print MACRO "image cent sele seq $seq_ID .a atom name CA end\n" ;
	    print MACRO "image hist center\n" ;
	    print MACRO "key active sele by resi atom numb \$1 end \n" ;
	    print MACRO "key passive sele by bond by resi active end \n" ;
	    print MACRO "return \n" ;
	}
    }
    elsif ( $FIELD eq "BOND" )
    {
	if ( !exists (  $item->{$my_field} ) ) 
	{ 
#	    print " bond> NEXT OUT $my_field \n" ; 
#	    print "inte->", $item->{$my_field}, "\n" ; 
#	    foreach my $kk ( keys %{$item->{$my_field}} )
#	    {
#		print " bond outlier $my_field key: $kk \n" ;
#	    }
	    next ; 
	}  
#	else 
#	{ 
#	    print " bond> NEXT IN $my_field \n" ;
#	}
	my $atom0 =  $item->{$my_field}{"atom0"} ;
	my $atom1 =  $item->{$my_field}{"atom1"} ;
#	print ": rama, seq : ", $item->{"rama"}, " ", $seq_ID, "\n" ;
	print MACRO "image cent sele seq $seq_ID .a atom name $atom0 end\n" ;
	print MACRO "image hist center\n" ;
	if ( $atom0 eq "C" && $atom1 eq "N" ) { $seq_ID++ ; }
	print MACRO "image cent sele seq $seq_ID .a atom name $atom1 end\n" ;
	print MACRO "image hist center\n" ;
	print MACRO "image hist distan\n" ;
	print MACRO "key active sele by resi atom numb \$1 end \n" ;
	print MACRO "key passive sele by bond by resi active end \n" ;
	print MACRO "return \n" ;
    }
    elsif ( $FIELD eq "ANGLE" )
    {
	if ( !exists (  $item->{$my_field} ) ) 
	{ 
#	    print " bond> NEXT OUT $my_field \n" ; 
#	    print "inte->", $item->{$my_field}, "\n" ; 
#	    foreach my $kk ( keys %{$item->{$my_field}} )
#	    {
#		print " bond outlier $my_field key: $kk \n" ;
#	    }
	    next ; 
	}  
#	else 
#	{ 
#	    print " angle> NEXT IN $my_field \n" ;
#	}
	my $atom0 =  $item->{$my_field}{"atom0"} ;
	my $atom1 =  $item->{$my_field}{"atom1"} ;
	my $atom2 =  $item->{$my_field}{"atom2"} ;
#	print ": rama, seq : ", $item->{"rama"}, " ", $seq_ID, "\n" ;
	print MACRO "image cent sele seq $seq_ID .a atom name $atom0 end\n" ;
	print MACRO "image hist center\n" ;
	print MACRO "image cent sele seq $seq_ID .a atom name $atom1 end\n" ;
	print MACRO "image hist center\n" ;
	if ( $atom0 eq "CA" && $atom1 eq "C" and $atom2 eq "N" ) { $seq_ID++ ; }
	print MACRO "image cent sele seq $seq_ID .a atom name $atom2 end\n" ;
	print MACRO "image hist center\n" ;
	print MACRO "image hist angle\n" ;
	print MACRO "key active sele by resi atom numb \$1 end \n" ;
	print MACRO "key passive sele by bond by resi active end \n" ;
	print MACRO "return \n" ;
    }
    elsif ( $FIELD eq "CLASH" )
    {
	if ( !exists (  $item->{$my_field} ) ) 
	{ 
#	    print " bond> NEXT OUT $my_field \n" ; 
#	    print "inte->", $item->{$my_field}, "\n" ; 
#	    foreach my $kk ( keys %{$item->{$my_field}} )
#	    {
#		print " bond outlier $my_field key: $kk \n" ;
#	    }
	    next ; 
	}  
#	else 
#	{ 
#	    print " bond> NEXT IN $my_field \n" ;
#	}
	my $atom =  $item->{$my_field}{"atom"} ;
	if ( substr($atom, 0,1) eq "H" ) { next ; }
#	print ": rama, seq : ", $item->{"rama"}, " ", $seq_ID, "\n" ;
	print MACRO "image cent sele seq $seq_ID .a atom name $atom end\n" ;
	print MACRO "image hist center\n" ;
	print MACRO "image hist neigh 2.9\n" ;
	print MACRO "key active sele by resi atom numb \$1 end \n" ;
	print MACRO "key passive sele by bond by resi active end \n" ;
	print MACRO "return \n" ;
    }
    elsif ( $FIELD eq "SYMM" )
    {
	if ( !exists (  $item->{$my_field} ) ) 
	{ 
	    next ; 
	}  
#	else 
#	{ 
#	    print " bond> NEXT IN $my_field \n" ;
#	}
	my $atom =  $item->{$my_field}{"atom"} ;
	if ( substr($atom, 0,1) eq "H" ) { next ; }
#	print ": rama, seq : ", $item->{"rama"}, " ", $seq_ID, "\n" ;
	print MACRO << "END_OF_TEXT" ;
image cent sele seq $seq_ID .a atom name $atom end
image hist center
dele atom sele segm name \#* end
symm select segm name WORK_SEGM end around center atom \$1  \\
   dist 6.0 neigh 2 
image hist neigh 2.9
image group name SYMMETRY
image sele segm name \#* end col 95 bond
image sele segm name \#* .a .n by bond all end col 95 atom cros
key active sele by resi atom numb \$1 end 
key passive sele by bond by resi active end 
return 
END_OF_TEXT
    }
    elsif ( $FIELD eq "FLIP" )
    {
	if ( !exists (  $item->{$my_field}{"flippable-sidechain"} ) ) 
	{ 
#	print "NOT : flippable, seq : ", keys ( %{$item} ) , " ", $seq_ID, " >>", $my_field, "\n" ;
	    next ; 
	}  
#	my $atom =  $item->{$my_field}{"flippable-sidechain"} ;
	print ": flippable, seq : ", $item->{"flippable-sidechain"}, "  $seq_ID $res_name \n" ;
	print MACRO "image cent sele seq $seq_ID .a atom name CA end\n" ;
	print MACRO "image hist center\n" ;
	print MACRO "key active sele by resi atom numb \$1 end \n" ;
	print MACRO "key passive sele by bond by resi active end \n" ;
	print MACRO "return \n" ;

    }
    else
    {
	print " else $FIELD \n" ;
    }
#	elsif ( $FIELD eq "ANGLE" )
#	{
#	}
#	elsif ( $FIELD eq "CLASH" )
#	{
#	}

} 

close ( MACRO ) ;

######################################

#if ( $FORM eq "ANALYSIS" ) { create_analysis_list () ; }
#if ( $FORM eq "PEAKS" ) { create_peak_list () ; }
#if ( $FORM eq "PDB" ) { create_pdb_list () ; }
}

sub validation_color_code
{

    my $color_green = 200 ;
    my $color_yellow = 156 ;
    my $color_red = 128 ;
    my $RAMA_NN = 0 ;
    my %rama_colors = ( 'Allowed', $color_yellow, 'Favored', $color_green, 'OUTLIER', $color_red ) ;



open ( MACRO,  "> $MACRO_FILE_COLOR" ) || die "FILE OPEN ERROR: >$MACRO_FILE_COLOR< \n" ;

print MACRO "set color sele all end = $color_green \n" ;

my $my_field = $lookup{ lc($FIELD) } ;
foreach my $item ( @xml_list )
{
#    print "my keys: $_ $item->{$_}\n", for keys %$item ;
#    print "my keys: $_ \n", for keys %$item ;

#print "--item->", $item, "\n" ;


    if ( !exists( $item->{"ModelledSubgroup"} ) ) { next ; }

#    print "my keys: $_ $item->{$_}\n", for keys %$item ;

    $seq_ID =  $item->{"ModelledSubgroup"}{"seq"} ; 
#    print " top> seq ID color: >$seq_ID< \n" ;
    my @chrs = split("",$seq_ID) ; # =~ s/\//g ;
    if ( $chrs[$#chrs] eq '/' ) { pop @chrs ; }
    $seq_ID = join("", @chrs ) ;
    next if ( $seq_ID eq "\." ) ;
#    print " seq ID color: >$seq_ID< \n" ;
    $res_num =  $item->{"ModelledSubgroup"}{"resnum"} ;
    $res_name =  $item->{"ModelledSubgroup"}{"resname"} ;
    $chain =  $item->{"ModelledSubgroup"}{"chain"} ;
    $model =  $item->{"ModelledSubgroup"}{"model"} ;
    
    if ( $FIELD eq "RAMA" )
    {
	if ( !exists( $item->{"ModelledSubgroup"}{"rama"} ) ) 
	{ 
	    print " NOT EXIST model data:> $seq_ID, $res_num, $res_name, $chain, $model, <:\n" ;
	    next ; 
	}
	    print "DOES EXIST model data:> $seq_ID, $res_num, $res_name, $chain, $model, <:\n" ;
	my $value =  $item->{$my_field}{"rama"} ;
	my $color = $rama_colors{$value} ;
	print MACRO "set color sele seq $seq_ID end = $color \n" ;
    }
    elsif ( $FIELD eq "ROTA" )
    {
	my $value =  $item->{$my_field}{"rota"} ;
	if ( $value eq "OUTLIER" )
	{
#	print ": rama, seq : ", $item->{"rama"}, " ", $seq_ID, "\n" ;
	    print MACRO "set color sele seq $seq_ID end = $color_red \n" ;
	}
	else
	{
	    print MACRO "set color sele seq $seq_ID end = $color_green \n" ;
	}
    }
    elsif ( $FIELD eq "BOND" )
    {
	if ( !exists (  $item->{$my_field} ) ) 
	{ 
#	    print " bond> NEXT OUT $my_field \n" ; 
#	    print "inte->", $item->{$my_field}, "\n" ; 
#	    foreach my $kk ( keys %{$item->{$my_field}} )
#	    {
#		print " bond outlier $my_field key: $kk \n" ;
#	    }
	    next ; 
	}  
#	else 
#	{ 
#	    print " bond> NEXT IN $my_field \n" ;
#	}
	my $atom0 =  $item->{$my_field}{"atom0"} ;
	my $atom1 =  $item->{$my_field}{"atom1"} ;
#	print ": rama, seq : ", $item->{"rama"}, " ", $seq_ID, "\n" ;
	print MACRO "set col sele seq $seq_ID .a atom name $atom0 end = $color_red\n" ;
	if ( $atom0 eq "C" && $atom1 eq "N" ) { $seq_ID++ ; }
	print MACRO "set col sele seq $seq_ID .a atom name $atom1 end = $color_red\n" ;
    }
    elsif ( $FIELD eq "ANGLE" )
    {
	if ( !exists (  $item->{$my_field} ) ) 
	{ 
#	    print " bond> NEXT OUT $my_field \n" ; 
#	    print "inte->", $item->{$my_field}, "\n" ; 
#	    foreach my $kk ( keys %{$item->{$my_field}} )
#	    {
#		print " bond outlier $my_field key: $kk \n" ;
#	    }
	    next ; 
	}  
#	else 
#	{ 
#	    print " angle> NEXT IN $my_field \n" ;
#	}
	my $atom0 =  $item->{$my_field}{"atom0"} ;
	my $atom1 =  $item->{$my_field}{"atom1"} ;
	my $atom2 =  $item->{$my_field}{"atom2"} ;
#	print ": rama, seq : ", $item->{"rama"}, " ", $seq_ID, "\n" ;
	print MACRO "set col sele seq $seq_ID .a atom name $atom0 $atom1 end = $color_red\n" ;
	if ( $atom0 eq "CA" && $atom1 eq "C" and $atom2 eq "N" ) { $seq_ID++ ; }
	print MACRO "set col sele seq $seq_ID .a atom name $atom2 end = $color_red\n" ;
    }
    elsif ( $FIELD eq "CLASH" )
    {
	if ( !exists (  $item->{$my_field} ) ) 
	{ 
#	    print " bond> NEXT OUT $my_field \n" ; 
#	    print "inte->", $item->{$my_field}, "\n" ; 
#	    foreach my $kk ( keys %{$item->{$my_field}} )
#	    {
#		print " bond outlier $my_field key: $kk \n" ;
#	    }
	    next ; 
	}  
#	else 
#	{ 
#	    print " bond> NEXT IN $my_field \n" ;
#	}
	my $atom =  $item->{$my_field}{"atom"} ;
	if ( substr($atom, 0,1) eq "H" ) { next ; }
#	print ": rama, seq : ", $item->{"rama"}, " ", $seq_ID, "\n" ;
	print MACRO "set col sele seq $seq_ID .a atom name $atom end = $color_red\n" ;
    }
    elsif ( $FIELD eq "SYMM" )
    {
	if ( !exists (  $item->{$my_field} ) ) 
	{ 
	    next ; 
	}  
#	else 
#	{ 
#	    print " bond> NEXT IN $my_field \n" ;
#	}
	my $atom =  $item->{$my_field}{"atom"} ;
	if ( substr($atom, 0,1) eq "H" ) { next ; }
#	print ": rama, seq : ", $item->{"rama"}, " ", $seq_ID, "\n" ;
	print MACRO "set col sele seq $seq_ID .a atom name $atom end = $color_red\n" ;
    }
    else

    {
	print " else $FIELD \n" ;
    }
#	elsif ( $FIELD eq "ANGLE" )
#	{
#	}
#	elsif ( $FIELD eq "CLASH" )
#	{
#	}

} 

    print MACRO "return \n" ;

######################################

#if ( $FORM eq "ANALYSIS" ) { create_analysis_list () ; }
#if ( $FORM eq "PEAKS" ) { create_peak_list () ; }
#if ( $FORM eq "PDB" ) { create_pdb_list () ; }
close ( MACRO ) ;

open ( MACRO,  "> $MACRO_FILE" ) || die "FILE OPEN ERROR: >$MACRO_FILE< \n" ;
    print MACRO "< $MACRO_FILE_COLOR \n" ;
    print MACRO "return \n" ;
close ( MACRO ) ;

}

sub read_xml_file
{

    my ( $XML_FILE ) =  @_ ;

    my @xml_records = () ;
    my $LINE ;
    open ( PDB_XML,  "< $XML_FILE" ) || print "xml report reading> FILE OPEN ERROR: >$XML_FILE< \n" ;
    while (<PDB_XML> ) { push(@xml_records, $_) ; } close ( PDB_XML ) ;

    my @chain_list = () ;


    my %subgroup = () ;
    my $subgroups = 0 ;
    my $one_line_group = "" ;
    
    foreach $LINE ( @xml_records )
    {
#	print " line: ", $LINE, "\n" ;
	chomp ( $LINE ) ;

	my @ss = split("", $LINE ) ;
	pop(@ss) ;
	
	my $line = join("", @ss ) ;

	my @words = split(" ", $line ) ;

	my $ll = $#words ;
	my $ll_wrd =  length($words[0]) -1 ;
	my $my_kind = substr($words[0], 1, $ll_wrd ) ;
#	print " $ll_wrd, first >$my_kind< ", $words[0], "< la $ll st >", $words[$ll], "<\n" ;
	if ( $my_kind eq "/ModelledSubgroup" ) 
	{
#	    print " -------------->>>>>>>  PUSH ", %subgroup , "\n";
	    my %new_hash = %subgroup ;
	    push( @chain_list, \%new_hash ) ;
	    next ;
	}

	if ( $my_kind eq "ModelledSubgroup" ) 
	{
	    %subgroup = () ;
	    $ll_wrd = length($words[$ll] ) -1 ;
	    $one_line_group = substr($words[$ll], $ll_wrd, 2 ) ;
#	    print " one line only:>", $one_line_group, "<\n" ;
	}
	my @items = @words[1..$ll] ;
	my $ii = -1;
	my @empty_list = () ;
	foreach my $ITEM ( @items )
	{
	    $ii++ ;
	    my @my_args = split("=", $ITEM) ;
	    
	    if ( length ($ITEM) == 1 && $ITEM eq '"' )
	    {
		push( @empty_list, $ii ) ;
	    }
#		print " $my_kind $ii items: >$ITEM< - >@my_args< list >@empty_list< \n" ;

	}
	foreach my $ii ( reverse @empty_list )
	{
	    $items[$ii-1] = $items[$ii-1] . ' "' ;
	    splice ( @items, $ii-1, 2 ) ;
#		print "new items $ii: >$items[$ii-1]<\n"
	}
	foreach my $ITEM ( @items )
	{
	    my @my_args = split("=", $ITEM) ;
	    $my_args[1] =~ s/\"//g ;
	    $subgroup{$my_kind}{$my_args[0]} = $my_args[1] ;
#		print " new items: >$ITEM< @my_args[0] <> $my_args[1] <\n" ;
	}
# 	    foreach my $key ( sort keys (%subgroup) )
# 	    {
# 		print "key :$key =>", $subgroup{$key}, "<\n" ;
# 	    }

	if ( $one_line_group eq "/" ) 
	{
#	    print "my PUSH keys: $_ $subgroup{$_}\n", for keys ( %subgroup ) ;
#	    foreach my $key ( keys  %subgroup  )
#	    {
#		foreach my $kk ( keys %{$subgroup{$key}} )
#		{
#		    print "my PUSH >$key-> $kk == $subgroup{$key}{$kk} \n" ;
#		}
#	    }
#	    print " -------------->>>>>>>  PUSH ", %subgroup , "\n";
	    my %new_hash = %subgroup ;
	    push( @chain_list, \%new_hash ) ;
	    next ;
	}
    }
#    @xml_records = @chain_list ;
#    return ( @xml_records ) ;
    print " length of the chain list:", $#chain_list , "\n";

    return ( @chain_list ) ;
}

