#!/usr/bin/env perl
use strict;
use lib $ENV{ 'MAIN_CONF'}  ;
use main_config ;
#use Tk;
#use Tk::Dialog;
use LWP::Simple;
use Cwd;

my %commands = () ;

if ( @ARGV <= 0 ) { push ( @{$commands{'help'}}, ' ' ) ; } 
else { (%commands) = main_config::get_commands ( @ARGV ) ; }

my @PDB_FILE = () ;
my @CIF_FILE = () ;
my $PROC_ERROR = "FALSE" ;
my $doit = "FALSE" ;

my $keyword ; 
foreach $keyword ( sort keys (%commands) ) 
{
#    print " $keyword \n" ;
    if ( $keyword eq 'h' || substr($keyword, 0,4) eq "help"   ) { goto HELP }
    if ( $keyword eq 'f' || substr($keyword, 0,3) eq "cif" ) { goto CIF }
    if ( $keyword eq 'p' || substr($keyword, 0,3) eq "pdb" ) { goto PDB }
    if ( substr($keyword, 0,4) eq "doit" ) { $doit = "TRUE" ; next ; }
    print "unknown option >$keyword<\n" ; $PROC_ERROR = "TRUE" ;

  HELP: 
    print << "END_OF_TEXT" ;
  -h|--help)     prints this message with available options and current status
  -p|--pdb)      extract information from a PDB file [@PDB_FILE]
  -f|--cif)      extract information from a CIF file [@CIF_FILE]
     --doit)     create the macro
END_OF_TEXT
    exit ;

 PDB:  @PDB_FILE = @{$commands{$keyword}} ; next ;
 CIF:  @CIF_FILE = @{$commands{$keyword}} ; next ;
}

if ( $PROC_ERROR eq "TRUE"  ) { exit ; }
if ( $doit eq "FALSE" )  { exit ; }

my $file_name ;
foreach $file_name ( @PDB_FILE )
{
    my $x_file_name = $file_name . ".pdb" ;
    getstore ("http://files.rcsb.org/download/$x_file_name", $x_file_name); 

}
