#!/usr/bin/perl -w
use strict;

print " @ARGV \n" ;

my $lab_file =  $ARGV[0] ;
my $lib_dir =   $ARGV[1] ;
my $matr_file = $ARGV[2] ;
my $out_file =  $ARGV[3] ;
my $chr_scal =  $ARGV[4] ;
my $line ;

my @labels = () ;
my @coords = () ;

my $nlab = 0 ;

open ( LAB, $lab_file ) || die ; 
while( $line = <LAB> )
{
    chomp( $line ) ;
    if ( $line == 11 ) 
    {
	if ( $line = <LAB> ) 
	{ chomp( $line ) ; push ( @coords, $line ); }
	if ( $line = <LAB> ) 
	{ chomp( $line ) ; push ( @labels, $line ); }
	$nlab++;
    }
}
close ( LAB ) ;

my @matr = () ;
open ( MATR, $matr_file ) || die "NO MATRIX FILE \n"; 
while( $line = <MATR> )
{
    chomp( $line ) ;
    push ( @matr, $line ); 
}
close ( MATR ) ;

$line = join (' ', @matr ) ;
my @mat33 = split(' ', $line ) ;

print "matrix: @mat33 \n" ;

open ( R3D, "> $out_file" ) || die "can not open OUT file: >$out_file<\n" ; 

my $i ;
my @xyz_s = () ;
my @xyz_e = () ;
my @xyz_lab = () ;

#$nlab = 1 ;

for ($i = 0; $i < $nlab ; $i++ )
{
    print $i, " coords: >", $coords[$i], "< \n" ;
    my @data = split( ' ', $coords[$i] ) ;
    my @xyz_lab = () ;
    $xyz_lab[0] = $data[0] ; 
    $xyz_lab[1] = $data[1] ;
    $xyz_lab[2] = $data[2] ;
    my $r_lab = $data[3] ;
    my $g_lab = $data[4] ;
    my $b_lab = $data[5] ;

#    print $i, " labels: >", $labels[$i], "< \n" ;
    my @letr = split('', $labels[$i] ) ;
    my $a ; my $x_shift = 0.0 ;
    foreach $a (@letr)
    {
	my $lib_file = join( '', $lib_dir, $a, '.r3d' ) ;
#	printf " TEST >$a<$lib_file> \n" ;
	open ( LIB, $lib_file ) || print "MISSING CHAR->$a<\n" ; 
	while ( $line = <LIB> )
	{ 
	    chomp ( $line ) ; # printf " OK CHAR>$a<  $line \n" ; 
	    my @cylinder = split ( ' ', $line ) ;
	    my $nelem = scalar(@cylinder) ;
	    if ( $nelem <= 1 ) 
	    {
		print R3D "3\n" ;
	    }
	    else
	    {
#		print " cylinder @cylinder \n" ;
		$xyz_s[0] = $cylinder[0]*$chr_scal + $x_shift ;
		$xyz_s[1] = $cylinder[1]*$chr_scal  ;
		$xyz_s[2] = $cylinder[2]*$chr_scal  ;
#		print " xyz_s @xyz_s \n" ;
		my ( $xs, $ys, $zs ) = rot_tran( \@xyz_s, \@mat33, \@xyz_lab ) ;
		
		$xyz_e[0] = $cylinder[4]*$chr_scal + $x_shift ;
		$xyz_e[1] = $cylinder[5]*$chr_scal ;
		$xyz_e[2] = $cylinder[6]*$chr_scal ;
#		print " xyz_e @xyz_e \n" ;
		my ( $xe, $ye, $ze ) = rot_tran( \@xyz_e, \@mat33, \@xyz_lab ) ;

		my $rad = $cylinder[3]*$chr_scal ;

		print R3D "$xs, $ys, $zs $rad $xe, $ye, $ze $rad $r_lab $g_lab $b_lab \n" ;
# die "DIED end here" ;
	    }
	}
	close ( LIB ) ;
	$x_shift = $x_shift + $chr_scal*0.13 ;
    }

}

sub rot_tran 
{
    my ( $x, $tr, $xtran) = @_ ;
    my @t = () ;
#    print " sub rot_tran x @$x \n" ;
#    print " sub rot_tran tr @$tr \n" ;
#    print " sub rot_tran xtran @$xtran \n" ;
    $t[0] = @$x[0]*@$tr[0] + @$x[1]*@$tr[1] + @$x[2]*@$tr[2] + @$xtran[0] ;
    $t[1] = @$x[0]*@$tr[3] + @$x[1]*@$tr[4] + @$x[2]*@$tr[5] + @$xtran[1] ;
    $t[2] = @$x[0]*@$tr[6] + @$x[1]*@$tr[7] + @$x[2]*@$tr[8] + @$xtran[2] ;
    
#    $t[0] = @$xtran[0] ;
#    $t[1] = @$xtran[1] ;
#    $t[2] = @$xtran[2] ;
#    print " sub rot_tran @t \n" ;
return ( @t ) ;
}
