! set variable for a unit cell map and read cell constants, reflection
! file and coordinates

set vari MAP_ONE = 1

read cell
*
   86.51    34.15    85.53     90.0   103.1  90.0

read file >symm/p21.symm symm
read file ../p21-b/cb-inh-p21.fobs refl resol 2.0 8.0 \
        limits -99 0 0 init
read file ../ca030/hucathb_13_temp.xpl_save coor xpl

! generate a unit cell map, fill it with atom density (including all
! symetry equivelent positions and set the empty region (-9999) to zero
! for later Fourier transformation

make map MAP_ONE from 0 init -9999 grid 128 54 128 real cell
make map MAP_ONE atom symm -
           atom dens -
           sele all end
make map MAP_ONE set -10000 0 0.

! Fourier transform the density map (MAP_ONE)
! and calculate r-values and scaling coeficients for each
! resolution shell individually  (B value is also calculated)

fourier map MAP_ONE
reflection shells 10 r-values 

! write the Fobs, Fcalc and the phase information of defined
! reflections (defined have Fobs > 0 )

write over file cb-inh-p21.phase refl fobs fcalc phase defined

! calculate a 2Fobs - Fcalc map  (scale Fcalc)

! clear the map and convert it into a complex map (for any case)

make map MAP_ONE zero
make map  MAP_ONE convert complex

! THIS PART DEFINES THE KIND OF MAP YOU WILL CALCULATE
! store the amplitude and phase information into the fworkset
! only fworkset can be used to fill the map for a 
! later Fourier back transform

! A 2Fobs - Fcalc map:

refl set ampl phase fwork = fcalc * 1.
refl set ampl scale fcalc     fwork = fobs * 2. - fcalc * 1.

! A Fobs - Fcalc map:

refl set ampl phase fwork = fcalc * 1.
refl set ampl scale fcalc     fwork = fobs * 1. - fcalc * 1.

! A Patterson Fobs map:

refl set ampl phase fwork = fobs ^ 2

! An Fcalc map with all reflection (P1 cell)
! you can also scale Fcalc with a resolution dependent B-value
! refl set temp 20. ampl phase scale fcalc   fwork = fcalc * 1.

refl set ampl phase fwork = fcalc * 1.


! only reflections with Fobs > 0 will be inserted into MAP_ONE map

refl fill-map  MAP_ONE defined

! perform back Fourier transformation of complex map MAP_ONE

four map  MAP_ONE back 
make map  MAP_ONE rescale 

! write the map to a file

write over file test.xmap map MAP_ONE xplor

quit

