! set proper file names
set level 2

set vari ATOM_COOR = "atoms.xpl"
set vari 2FO-FC_MAP  = "map.2fofc"
set vari FO-FC_MAP = "map.1fofc"
set vari WATER_OUT = "water.xpl"
set vari SYMMETRY = ">symm/p21.symm"

! read topology library and the coordinate file in X-PLOR format
<>utils/get_top_par_19_csd
read file ATOM_COOR coordinates  xplor

! reads both electron density files
read file 2FO-FC_MAP map xplor ! 2Fo - Fc 
read file FO-FC_MAP  map xplor ! Fo - Fc
read file SYMMETRY symmetry

set vari WORK_SEGM char segm sele all end
set vari PROTEIN   char segm select .not resi name H2O end

<?MAIN_UTILS:gen_solvent 1 2 WORK_SEGM PROTEIN

! you can use also your local gen_solven.com file instead of using 
! the default cutoffs present MAIN_UTILS:gen_solvent.com file.

! It remains to write the results.

write over file WATER_OUT select segm name WAT WAT2 end coordi  xpl

quit
