set vari FILE_ATOM = "model_1.pdb"
set vari FILE_CTAB = model_1.ctab

set vari FILE_SYMM = ">symm/p21_21_21.symm"
set vari FILE_FOBS = "gx_pt1ph.phase"
set vari FILE_CELL = "cell.dat"

set vari RESOL_MIN global = 50.0
set vari RESOL_MAX global = 3.3

set vari MAP_2FOFC global = 1
set vari MAP_FOFC global = 2
set vari MAP_FO global = 1
set vari MAP_WORK global = 2

<>utils/get_top_par_19_csd

read file FILE_ATOM coor xpl
set vari WORK_SEGM char global segm sele all end 

read file FILE_CTAB ctable
show bonds
if ( IRESULT_0 .le. 0 ) <>utils/calculate.bonds WORK_SEGM

<DEF_ALL WORK_SEGM
define init group 
set charge sele .not atom name C CA N H O .a \
    resi name ASP GLU LYS ARG end = 0.0

read file FILE_CELL cell
read file FILE_SYMM symm

read file FILE_FOBS refl init limit 0 0 0 re_read \
     reso RESOL_MIN RESOL_MAX ! re_read friedel

! overwrites the figure of merit weights on FOBS
refl weigh const


make map 1 from 0 init -9999 auto_grid cell real
make map 2 from 1 init -9999 
copy map 2 3

ener all on dens on dens map MAP_2FOFC dens scal 25.

!<?MAIN_CMDS:re_phase.cmds WORK_SEGM MAP_FOFC
!<?MAIN_CMDS:calc_2fofc_map.cmds MAP_2FOFC

! the part performing the AMoRe solution which is not in a standard read.com

rename segm ORIG sele segm name WORK_SEGM end

! use tabling only if you need to reorient your molecule

<MAIN_UTILS:amore_from_tabling.com ORIG 30. 89. 46. 20. 74. -89.

menu block GUESS create
menu block GUESS color 160
menu block GUESS document >doc/menu/GUESS.txt
menu block GUESS item OPEN add text "open unit 24 file solutions_list.com"
menu block GUESS item NEXT add text "stream unit 24"
menu block GUESS item CLOSE add text "close unit 24"
menu page 10 add GUESS

! end of AMoRe interface insertion

ima init cent calc
<model.view
!<>utils/rama
<>utils/show.cell

!ima sele atom name CA C N end col 1 bond

ima from erase
 ima col 245 map 1 dens 0.8 12 12 12

<?MAIN_CMDS:re_image.cmds WORK_SEGM

return
