#!/usr/bin/perl -w
use strict;
use lib $ENV{ 'MAIN_CONF'}  ;
use main_config ;

print " @ARGV \n" ;

my %commands = () ;

if ( @ARGV <= 0 ) { push ( @{$commands{'help'}}, ' ' ) ; } 
else { (%commands) = main_config::get_commands ( @ARGV ) ; }

######################################################

my $FILE_INPUT = "CE.log" ;
my $FILE_OUTPUT_SEQ = "seq_align_out.txt" ;
my $FILE_MAIN_PAIRS = "seq_pairs" ;
my $FILE_MATRIX = "CE_matrix.com" ;
my $FILE_MAIN_COLORS = "seq_colors" ;
my $PROC_ERROR = "FALSE" ;
my $doit = "FALSE" ;
my $SEGM ;
my @reorder = () ;
my @translate = ();
my $K_BARS = 5 ;

my $keyword ; 
foreach $keyword ( sort keys (%commands) ) 
{
    if ( $keyword eq 'h' || $keyword eq '?' || substr($keyword, 0,4) eq "help" ) { goto HELP }
    if ( $keyword eq 'i' || substr($keyword, 0,5) eq "input" ) { goto INPUT }
    if ( $keyword eq 'o' || substr($keyword, 0,6) eq "output" ) { goto OUTPUT }
    if ( $keyword eq 'c' || substr($keyword, 0,11) eq "main_colors" ) { goto MAIN_COLORS }
    if ( $keyword eq 'm' || substr($keyword, 0,6) eq "matrix" ) { goto MATRIX }
    if ( $keyword eq 'p' || substr($keyword, 0,10) eq "main_pairs" ) { goto MAIN_PAIRS }
    if ( $keyword eq 'r' || substr($keyword, 0,7) eq "reorder" ) { goto REORDER }
    if ( $keyword eq 't' || substr($keyword, 0,9) eq "translate" ) { goto TRANSLATE }
    if ( $keyword eq 'b' || substr($keyword, 0,4) eq "bars" ) { goto BARS }
    if ( substr($keyword, 0,4) eq "doit" ) { $doit = "TRUE" ; next ; }
    print "unknown option >$keyword<\n" ; $PROC_ERROR = "TRUE" ;

#  -c|--ctab)       file with molecular connectivity table [@{$my_main{"FILE_CTAB"}}]
  HELP:
    print << "END_OF_TEXT" ;
  -h|-help|--help)  prints this message with available options and current status 
  -i|--input)       input with matrix data [$FILE_INPUT]
  -o|--output)      h aligned sequences for publication [$FILE_OUTPUT_SEQ]
  -m|--matrix)      macro with superimposition of matrix data [$FILE_MATRIX]
  -p|--main_pairs)  macro with MAIN pairing [$FILE_MAIN_PAIRS]
  -c|--main_colors) macro with MAIN pairing [$FILE_MAIN_COLORS]
     --doit)       do the work
END_OF_TEXT
    exit ;


 OUTPUT: $FILE_OUTPUT_SEQ = shift ( @{$commands{$keyword}} ) ; next ;
 INPUT: $FILE_INPUT = shift ( @{$commands{$keyword}} ) ; next ;
 MATRIX: $FILE_MATRIX = shift ( @{$commands{$keyword}} ) ; next ;
 MAIN_PAIRS: $FILE_MAIN_PAIRS = shift ( @{$commands{$keyword}} ) ; next ;
 MAIN_COLORS: $FILE_MAIN_COLORS = shift ( @{$commands{$keyword}} ) ; next ;
 REORDER: @reorder = @{$commands{$keyword}} ; next ;
 TRANSLATE: @translate = @{$commands{$keyword}} ; next ;
 BARS: $K_BARS = shift (@{$commands{$keyword}}) ; next ;
}

if ( $PROC_ERROR eq "TRUE" ) { exit ; }

#######################################

my @id_list ;
my %seq_data ;
my $id ;
my @matrix33 ;
my @tran3 ;

print " file input : $FILE_INPUT \n" ;

print " file input other : $FILE_INPUT \n" ;
my ( $ref_seq_data, $ref_id_list, $ref_matrix, $ref_tran3) 
    = main_config::read_jCE_file ( $FILE_INPUT ) ; 
%seq_data = %{$ref_seq_data} ;
@id_list = @{$ref_id_list} ;
@matrix33 = @{$ref_matrix} ;
@tran3 = @{$ref_tran3} ;

open ( MACRO,  "> $FILE_MATRIX" ) || die "FILE OPEN ERROR: >$FILE_MATRIX< \n" ;

    print MACRO " set matrix 3 number -\n" ;
    print MACRO join( " ", @{$matrix33[0]}), " -\n" ;
    print MACRO join( " ", @{$matrix33[1]}), " -\n" ;
    print MACRO join( " ", @{$matrix33[2]}), "\n" ;

    print MACRO " set vari XTRAN global real = ", $tran3[0], "\n" ;
    print MACRO " set vari YTRAN global real = ", $tran3[1], "\n" ;
    print MACRO " set vari ZTRAN global real = ", $tran3[2], "\n" ;
    print MACRO " return\n" ;

close ( MACRO ) ;

