#!/usr/bin/perl -w
use strict;
use lib $ENV{ 'MAIN_CONF'}  ;
use main_config ;
my %commands = () ;

if ( @ARGV <= 0 ) { push ( @{$commands{'help'}}, ' ' ) ; } 
else { (%commands) = main_config::get_commands ( @ARGV ) ; }

######################################################

my $MACRO_FILE = "center_next.com" ;
my $VALIDATE_FILE = "validate.dat" ;
my $TOP_LIST = "50" ;
my $PROC_ERROR = "FALSE" ;
my $doit = "FALSE" ;

my $keyword ; 
foreach $keyword ( sort keys (%commands) ) 
{
    if ( $keyword eq 'h' || substr($keyword, 0,4) eq "help" ) { goto HELP }
    if ( $keyword eq 'o' || substr($keyword, 0,6) eq "output" ) { goto OUTPUT }
    if ( $keyword eq 'i' || substr($keyword, 0,5) eq "input" ) { goto INPUT }
    if ( substr($keyword, 0,4) eq "doit" ) { $doit = "TRUE" ; next ; }
    print "unknown option >$keyword<\n" ; $PROC_ERROR = "TRUE" ;

HELP:
    print << "END_OF_TEXT" ;
  -h|--help)    prints this message with available options and current status 
  -o|--output)  set file name of the created macro [$MACRO_FILE]
  -i|--input)   set file name of the validation input [$VALIDATE_FILE]
  -c|--cutoff)  top [$TOP_LIST]
     --doit)    create the macro
END_OF_TEXT
    exit;

OUTPUT: $MACRO_FILE = shift ( @{$commands{$keyword}} ) ; next ;
INPUT: $VALIDATE_FILE = shift ( @{$commands{$keyword}} ) ; next ;
CUTOFF: $TOP_LIST = shift ( @{$commands{$keyword}} ) ; next ;
}
if ( $PROC_ERROR eq "TRUE" ) { exit ; }

#######################################

if ( $doit eq "FALSE" )  { exit ; }

######################################



open ( TXT,  "< $VALIDATE_FILE" ) || die "FILE OPEN ERROR: >$VALIDATE_FILE< \n" ;

my %aver_list = () ;
my $key ;
my @words = () ;
while(<TXT>)
{
    chomp ;
    my $line = $_ ;
    @words = split(" ", $line) ;
    $key = $words[1] ;
    $aver_list{$key} = $words[9] ;
#    print " ead in :", $words[9], $words[8], $words[7], $words[1], "\n" ;
}

print "creating \"$MACRO_FILE\" \n" ;
if ( -f $MACRO_FILE ) 
{ 
    my $back = join ('', $MACRO_FILE, ".old" ) ; 
    system ( "mv  $MACRO_FILE $back" ) ; 
}

open ( MACRO,  "> $MACRO_FILE" ) || die "FILE OPEN ERROR: >$MACRO_FILE< \n" ;


foreach $key ( sort keys (%aver_list) ) 
{
#    print " key:", $key, " ++ ", $aver_list{$key}, "\n" ;
print MACRO << "END_OF_TEXT" ; 

set vari NEXT_RESI int global = $aver_list{$key}
return
END_OF_TEXT
}

close ( MACRO ) ;
