#!/usr/bin/perl -w
use strict;
#$my $test_key = 'Malhotra et al., 1998' ;
#print ">$test_key<\n" ;
print " @ARGV \n" ;
my %commands = () ;
my $out_file = "makefile.example";
my $out_style = "LINUX_G95-64" ;
my $DEBUG_STAT  = "OFF" ;
my $OPT  = "-O2" ;
my $XLIBS = "DEFAULT" ;

(%commands) = get_commands ( @ARGV ) ;
if ( scalar(@ARGV) <= 0 ) { push ( @{$commands{'help'}}, ' ' ) ; } 
my $i = 0 ; my $keyword ; 
foreach $keyword ( sort keys (%commands) ) 
{
    $i++ ; 
    print "$i.) >$keyword<:  @{$commands{$keyword}}\n";
    if ( $keyword eq 'd' || substr($keyword, 0,5) eq "debug"  ) { goto DEBUG }
    if ( $keyword eq 'f' || substr($keyword, 0,8) eq "makefile"  ) { goto FILE }
    if ( $keyword eq 'o' || substr($keyword, 0,8) eq "optimize"  ) { goto OPTIMIZE }
    if ( $keyword eq 'p' || substr($keyword, 0,5) eq "platform" ) { goto PLATFORM }
    if ( $keyword eq 'x' || substr($keyword, 0,4) eq "xlib" ) { goto XLIB }
    if ( $keyword eq 'h' || substr($keyword, 0,4) eq "help" ) { goto HELP }
    print "REF_MAN: unknown keyword >$keyword<\n" ;
    next ;
    
  HELP:
    print" -f/--makefile     make file name to be created >$out_file< \n" ;
    print" -d/--debug        debug flags [ON/OFF]  >$DEBUG_STAT< \n" ;
    print" -o/--optimize     optimization level    >$OPT< \n" ;
    print" -p/--platform     platform for the make file >$out_file< \n" ;
    print"             [LINUX_G77-32/LINUX_G77-64] \n" ;
    print"             [LINUX_G95-32/LINUX_G95-64] \n" ;
    print"             [OSX_G77-POWERPC/OSX_G95-POWERPC/OSX_G95-INTEL] \n" ;
    print" -x/--xlib         xlibraries directory    >$XLIBS< \n" ;
    exit ;
  DEBUG: 
	$DEBUG_STAT = shift ( @{$commands{$keyword}} ) ; 
	next ;
  OPTIMIZE: 
    $OPT = shift ( @{$commands{$keyword}} ) ; 
    if ( substr($OPT, 0,1) ne "-" ) { $OPT = "-" . $OPT ; }
	next ;
  FILE: 
	$out_file = shift ( @{$commands{$keyword}} ) ; 
	next ;
  PLATFORM: 
	$out_style = join ( '', @{$commands{$keyword}} ) ; 
#    print "REF_MAN: STYLE >$out_style< \n" ;
	next ;
  XLIB: 
	$XLIBS = shift ( @{$commands{$keyword}} ) ; 
	next ;

}

my $PLATFORM;
my $PLATFORM_FLAG;

my $CPP;

my $FC ;
my $WARNINGS;
my $WARNINGS_OFF;
my $GRAPHICS;
my $FDEBUG;
my $FFLAGS_FFT;
my $FFLAGS;
my $FFLAGS_2;

my $CFLAGS;

my $GL_LIBS ;
my $LIBS ;

my $LDFLAGS = "";

my $OBJ_BODY ;
my $OBJ_GRAPH ;
my $OBJ_ALL ;
my $MAKE_BODY ;
my $MAKE_GRAPH ;


$PLATFORM = $out_style ;


if ( $out_style eq "LINUX_G77-32" )
{
    $PLATFORM = $out_style ;
    $PLATFORM_FLAG = "-m32" ;
    $WARNINGS_OFF = "" ;
    if ( $DEBUG_STAT eq "ON" ) 
    {
	$FDEBUG = "-Wall -fbounds-check -g" ;
	$OPT = "-O0" ;
    }
    else
    {
	$FDEBUG = "-Wall" ;
    }
    $GRAPHICS = "-DOPENGL -DNVIDIA";
    $FFLAGS_FFT =  "-O2 -c" ;
    $FFLAGS = join( " ", "-c", $OPT, $WARNINGS_OFF,  $FDEBUG);
    $FFLAGS_2 = join( " ", "-c", $OPT, $WARNINGS_OFF,  $FDEBUG);
    $FC = join( " ", "/usr/bin/g77 -DG77",  $PLATFORM_FLAG );
    $CPP = "cat";
    $CFLAGS = join( " ", "-c", "-I/usr/X11/include -funroll-loops -pedantic -ffast-math -DLINUX", 
		    $GRAPHICS, $PLATFORM_FLAG ) ;
    $GL_LIBS = "/usr/lib/libGL.so /usr/lib/libGLU.so" ;
    $LIBS = "-L/usr/lib -lX11 -lXext -lXi" ;
    $OBJ_BODY = join ("", "*.o_", $PLATFORM ) ;
    $OBJ_GRAPH = join ("", "graph/*.o_", $PLATFORM ) ;
    $OBJ_ALL = join (" ", $OBJ_BODY, $OBJ_GRAPH ) ;
    $MAKE_BODY = ".make_body" ;
    $MAKE_GRAPH = ".make_graph" ;
}

if ( $out_style eq "OSX_G77-POWERPC" )
{
    $PLATFORM = $out_style ;
    $PLATFORM_FLAG = "" ;
    $WARNINGS_OFF = "" ;
    if ( $DEBUG_STAT eq "ON" ) 
    {
	$FDEBUG = "-Wall -fbounds-check -g" ;
	$OPT = "-O0" ;
    }
    else
    {
	$FDEBUG = "-Wall" ;
    }
    $GRAPHICS = "-DOPENGL";
    $FFLAGS_FFT =  "-O2 -c" ;
    $FFLAGS = join( " ", "-c", $OPT, $WARNINGS_OFF,  $FDEBUG);
    $FFLAGS_2 = join( " ", "-c", $OPT, $WARNINGS_OFF,  $FDEBUG);
    $FC = join( " ", "g77 -DG77",  $PLATFORM_FLAG );
    $CPP = "cat";
    $CFLAGS = join( " ", "-c", "-I/usr/X11R6/include/ -funroll-loops -pedantic -ffast-math -DLINUX -DOSX", 
		    $GRAPHICS, $PLATFORM_FLAG ) ;
    $GL_LIBS = "-lGL -lGLU" ;
    $LIBS = "-L/usr/X11R6/lib -lX11 -lXext -lXi" ;
    $OBJ_BODY = join ("", "*.o_", $PLATFORM ) ;
    $OBJ_GRAPH = join ("", "graph/*.o_", $PLATFORM ) ;
    $OBJ_ALL = join (" ", $OBJ_BODY, $OBJ_GRAPH ) ;
    $MAKE_BODY = ".make_body" ;
    $MAKE_GRAPH = ".make_graph" ;
}


if ( $out_style eq "OSX_G95-POWERPC" )
{
    $PLATFORM = $out_style ;
    $PLATFORM_FLAG = "-DOSX" ;
    $WARNINGS_OFF = "-Wno=101 -Wno=112 -Wno=137 -Wno=140" ;
    if ( $DEBUG_STAT eq "ON" ) 
    {
	$FDEBUG = "-Wall -fbounds-check -g" ;
	$OPT = "-O0" ;
    }
    else
    {
	$FDEBUG = "-Wall" ;
    }
    $GRAPHICS = "-DOPENGL";
    $FFLAGS_FFT =  "-O2 -c" ;
    $FFLAGS = join( " ", "-c", $OPT, $WARNINGS_OFF,  $FDEBUG);
    $FFLAGS_2 = join( " ", "-c", $OPT, $WARNINGS_OFF,  $FDEBUG);
    $FC = join( " ", "g95 -DFORTRAN_95 -ffixed-form -ffixed-line-length-132 -ftrace=full",  $PLATFORM_FLAG );
    $CPP = "to_f95.pl";
    $CFLAGS = join( " ", "-c", "-I/usr/X11R6/include/ -funroll-loops -pedantic -ffast-math -DLINUX -DOSX", 
		    $GRAPHICS, $PLATFORM_FLAG ) ;
    $GL_LIBS = "-lGL -lGLU" ;
    $LIBS = "-L/usr/X11R6/lib -lX11 -lXext -lXi" ;
    $OBJ_BODY = join ("", "*.o_", $PLATFORM ) ;
    $OBJ_GRAPH = join ("", "graph/*.o_", $PLATFORM ) ;
    $OBJ_ALL = join (" ", $OBJ_BODY, $OBJ_GRAPH ) ;
    $MAKE_BODY = ".make_body_f95" ;
    $MAKE_GRAPH = ".make_graph_f95" ;
}


if ( $out_style eq "LINUX_G77-64" )
{
    $PLATFORM = $out_style ;
    $PLATFORM_FLAG = "-m64" ;
    $WARNINGS_OFF = "" ;
    if ( $DEBUG_STAT eq "ON" ) 
    {
	$FDEBUG = "-Wall -fbounds-check -g" ;
	$OPT = "-O0" ;
    }
    else
    {
	$FDEBUG = "-Wall" ;
    }
    $GRAPHICS = "-DOPENGL -DNVIDIA";
    $FFLAGS_FFT = "-O2 -c" ;
    $FFLAGS = join( " ", "-c", $OPT, $WARNINGS_OFF,  $FDEBUG);
    $FFLAGS_2 = join( " ", "-c", $OPT, $WARNINGS_OFF,  $FDEBUG);
    $FC = join( " ", "/usr/bin/g77 -DG77",  $PLATFORM_FLAG );
    $CPP = "cat";
    $CFLAGS = join( " ", "-c", "-I/usr/X11/include -funroll-loops -pedantic -ffast-math -DLINUX", 
		    $GRAPHICS, $PLATFORM_FLAG ) ;
    $GL_LIBS = "/usr/lib64/libGL.so /usr/lib64/libGLU.so" ;
    $LIBS = "-L/usr/lib64 -lX11 -lXext -lXi" ;
    $OBJ_BODY = join ("", "*.o_", $PLATFORM ) ;
    $OBJ_GRAPH = join ("", "graph/*.o_", $PLATFORM ) ;
    $OBJ_ALL = join (" ", $OBJ_BODY, $OBJ_GRAPH ) ;
    $MAKE_BODY = ".make_body" ;
    $MAKE_GRAPH = ".make_graph" ;
}

if ( $out_style eq "OSX_G95-INTEL" )
{
    $PLATFORM = $out_style ;
    $PLATFORM_FLAG = "-DOSX" ;
    $WARNINGS_OFF = "-Wno=101 -Wno=112 -Wno=137 -Wno=140" ;
    if ( $DEBUG_STAT eq "ON" ) 
    {
	$FDEBUG = "-Wall -fbounds-check -g" ;
	$OPT = "-O0" ;
    }
    else
    {
	$FDEBUG = "-Wall" ;
    }
    $GRAPHICS = "-DOPENGL";
    $FFLAGS_FFT = "-O2 -c" ;
    $FFLAGS = join( " ", "-c", $OPT, $WARNINGS_OFF,  $FDEBUG);
    $FFLAGS_2 = join( " ", "-c", $OPT, $WARNINGS_OFF,  $FDEBUG);
    $FC = join( " ", "g95 -DFORTRAN_95 -ffixed-form -ffixed-line-length-132 -ftrace=full",  $PLATFORM_FLAG );
    $CPP = "to_f95.pl";
    $CFLAGS = join( " ", "-c", "-I/usr/X11R6/include -funroll-loops -pedantic -ffast-math -DLINUX", 
		    $GRAPHICS, $PLATFORM_FLAG ) ;
    $GL_LIBS = "-lGL -lGLU" ;

#	-lGL -lGLU -Wl,-dylib_file,/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib:/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib

    $LIBS = "-L/usr/X11R6/lib/ -lX11 -lXext -lXi" ;
    $OBJ_BODY = join ("", "*.o_", $PLATFORM ) ;
    $OBJ_GRAPH = join ("", "graph/*.o_", $PLATFORM ) ;
    $OBJ_ALL = join (" ", $OBJ_BODY, $OBJ_GRAPH ) ;
    $MAKE_BODY = ".make_body_f95" ;
    $MAKE_GRAPH = ".make_graph_f95" ;
}

if ( $out_style eq "LINUX_G95-32" )
{
    $PLATFORM = $out_style ;
    $PLATFORM_FLAG = "-m32" ;
    $WARNINGS_OFF = "-Wno=101 -Wno=112 -Wno=137 -Wno=140" ;
    if ( $DEBUG_STAT eq "ON" ) 
    {
	$FDEBUG = "-Wall -fbounds-check -g" ;
	$OPT = "-O0" ;
    }
    else
    {
	$FDEBUG = "-Wall" ;
    }
    $GRAPHICS = "-DOPENGL -DNVIDIA";
    $FFLAGS_FFT = "-O2 -c" ;
    $FFLAGS = join( " ", "-c", $OPT, $WARNINGS_OFF,  $FDEBUG);
    $FFLAGS_2 = join( " ", "-c", $OPT, $WARNINGS_OFF,  $FDEBUG);
    $FC = join( " ", "g95 -DFORTRAN_95 -ffixed-form -ffixed-line-length-132 -ftrace=full",  $PLATFORM_FLAG );
    $CPP = "to_f95.pl";
    $CFLAGS = join( " ", "-c", "-I/usr/X11/include -funroll-loops -pedantic -ffast-math -DLINUX", 
		    $GRAPHICS, $PLATFORM_FLAG ) ;
    $GL_LIBS = "/usr/lib/libGL.so /usr/lib/libGLU.so" ;
    $LIBS = "-L/usr/lib -lX11 -lXext -lXi" ;
    $OBJ_BODY = join ("", "*.o_", $PLATFORM ) ;
    $OBJ_GRAPH = join ("", "graph/*.o_", $PLATFORM ) ;
    $OBJ_ALL = join (" ", $OBJ_BODY, $OBJ_GRAPH ) ;
    $MAKE_BODY = ".make_body_f95" ;
    $MAKE_GRAPH = ".make_graph_f95" ;
}

if ( $out_style eq "LINUX_G95-64" )
{
    $PLATFORM = $out_style ;
    $PLATFORM_FLAG = "-m64" ;
    $WARNINGS_OFF = "-Wno=101 -Wno=112 -Wno=137 -Wno=140" ;
    if ( $DEBUG_STAT eq "ON" ) 
    {
	$FDEBUG = "-Wall -fbounds-check -g" ;
	$OPT = "-O0" ;
    }
    else
    {
	$FDEBUG = "-Wall" ;
    }
    $GRAPHICS = "-DOPENGL -DNVIDIA";
    $FFLAGS_FFT = "-O2 -c" ;
    $FFLAGS = join( " ", "-c", $OPT, $WARNINGS_OFF,  $FDEBUG);
    $FFLAGS_2 = join( " ", "-c", $OPT, $WARNINGS_OFF,  $FDEBUG);
    $FC = join( " ", "g95 -DFORTRAN_95 -ffixed-form -ffixed-line-length-132 -ftrace=full",  $PLATFORM_FLAG );
    $CPP = "to_f95.pl";
    $CFLAGS = join( " ", "-c", "-I/usr/X11/include -funroll-loops -pedantic -ffast-math -DLINUX", 
		    $GRAPHICS, $PLATFORM_FLAG ) ;
    $GL_LIBS = "/usr/lib64/libGL.so /usr/lib64/libGLU.so" ;
    $LIBS = "-L/usr/lib64 -lX11 -lXext -lXi" ;
    $OBJ_BODY = join ("", "*.o_", $PLATFORM ) ;
    $OBJ_GRAPH = join ("", "graph/*.o_", $PLATFORM ) ;
    $OBJ_ALL = join (" ", $OBJ_BODY, $OBJ_GRAPH ) ;
    $MAKE_BODY = ".make_body_f95" ;
    $MAKE_GRAPH = ".make_graph_f95" ;

}


print " creating: >$out_file< platform: >$out_style< \n" ;

write_file ( $out_file ) ;

exit ;


sub write_file
{
    use FileHandle ;
    my $file_name = shift ; 
    
    open( TXT, ">$file_name" )  || die ; 
#    my $TXT = new FileHandle ( "> $file_name" )  || die ; 
    if ( $XLIBS ne "DEFAULT" ) 
{
#    print " LIBS top", $LIBS, "\n" ;
    my @words = split (" ", $LIBS) ;
    $words[0] = "-L" . $XLIBS ;
    $LIBS = join ( " ", @words) ;
#    print " LIBS modified", $LIBS, "\n" ;
}

    print TXT << "END_OF_TEXT" ;

LDFLAGS = $LDFLAGS
FDEBUG = $FDEBUG
OPT = $OPT
PLATFORM_FLAG = $PLATFORM_FLAG 
PLATFORM = $PLATFORM

WARNINGS_OFF = $WARNINGS_OFF 
GRAPHICS = $GRAPHICS
FFLAGS_FFT = $FFLAGS_FFT
FFLAGS     = $FFLAGS    
FFLAGS_2   = $FFLAGS_2  
FC = $FC


CPP = $CPP
CFLAGS = $CFLAGS

OBJ_BODY = $OBJ_BODY
OBJ_GRAPH =  $OBJ_GRAPH
OBJ_ALL = $OBJ_ALL


ALL: main_LINUX

main_LINUX:  
	cd \$\(MAIN\)source ; rm -f *.F ; \\
	make -f $MAKE_BODY body CPP='${CPP}' \\
	FC=\'\${FC}\' FFLAGS=\'\${FFLAGS}\' FFLAGS_2=\'\${FFLAGS_2}\' \\
	FFLAGS_FFT=\'\${FFLAGS_FFT}\' PLFRM=$PLATFORM ; \\
	cd graph ; rm -f *.F ; make -f $MAKE_GRAPH CPP=\'\${CPP}\' \\
	FC=\'\${FC}\' FFLAGS=\'\${FFLAGS} \${GRAPHICS}\' FFLAGS_2=\'\${FFLAGS_2} \${GRAPHICS}\' \\
	CC=\'\${CC}\' CFLAGS=\'\${CFLAGS}\' PLFRM=$PLATFORM ; \\
	cd .. ; \\
	\$\(FC\) \$\(OBJ_ALL\) -o \$\(MAIN\)new.exe_$PLATFORM \\
	$GL_LIBS $LDFLAGS $LIBS

END_OF_TEXT

    close (TXT) ;

}


sub get_commands
{
    my $key = "" ;
    my $word ;
    my %c_line = () ;
    my @arg_char = () ;
    foreach $word ( @_ )
    {
	@arg_char = split( '', $word ) ;
#	print "word: $word \n" ; 
	if ( length($word) <= 0 ) { next ; }
	if ( $word !~ m"[a-zA-F]" ) { } #print "word: $word is a number\n" ; }
	else 
	{ 
#	    print "word: $word is a NON-number\n" ; 

	    if ( $arg_char[0] eq '-' ) 
	    {
		if ( $arg_char[1] eq "-" ) 
		{
		    my $num = scalar(@arg_char) - 1;
		    $key = join ( "", @arg_char[2 .. $num] );
		    push ( @{$c_line{$key}}, ' ' ) ; 
		}
		else
		{
		    $key = $arg_char[1] ; 
		    push ( @{$c_line{$key}}, ' ' ) ; 
		}
		next ;
	    }
	}

	if ( $key ne '' ) 
	{ 
	    $key = lc ( $key ) ; 
#	print "$key: \n" ;
	    my $tmp = join ( '', @{$c_line{$key}} ) ; 
	    if ( $tmp eq ' ' ) { delete $c_line{$key} ; }
	    push ( @{$c_line{$key}}, $word ); 
	}
    }
    return ( %c_line ) ;
}

