#!/usr/bin/perl -w
# use strict;
# print " @ARGV \n" ;
my %commands = () ;
my $in_file = "lit.txt" ;
my $in_form = "f77" ;
my $out_file = "script.txt";
my $out_dir = "CF95";
my $out_style = "common";
my @my_in_files = () ;
my @params = ("NATOMS", "NRSDS" ) ;
#my @params = ( "NRSDS" ) ;

(%commands) = get_commands ( @ARGV ) ;
if ( scalar(@ARGV) <= 0 ) { push ( @{$commands{'help'}}, ' ' ) ; } 
my $i = 0 ; my $keyword ; 
foreach $keyword ( sort keys (%commands) ) 
{
    $i++ ; 
    print "$i.) >$keyword<:  @{$commands{$keyword}}\n";
    if ( $keyword eq 'i' || substr($keyword, 0,2) eq "in"  ) { goto IN }
    if ( $keyword eq 'o' || substr($keyword, 0,3) eq "out"  ) { goto OUT }
    if ( $keyword eq 's' || substr($keyword, 0,5) eq "style" ) { goto STYLE }
    if ( $keyword eq 'h' || substr($keyword, 0,4) eq "help" ) { goto HELP }
    print "REF_MAN: unknown keyword >$keyword<\n" ;
    next ;
    
  HELP:
    print" -i/--inp     input file >$in_file< and form [f77/f95] >$in_form< \n" ;
    print" -o/--out     output directory >$out_dir< \n" ;
    print" -p/--params  output file >", join(" ", @params), "< \n" ;
    exit ;
  IN: 
	@my_in_files = @{$commands{$keyword}} ; 
#	$in_file = shift ( @{$commands{$keyword}} ) ; 
#	$in_form = lc(shift ( @{$commands{$keyword}}) ) ; 
	next ;
  OUT: 
	$out_file = shift ( @{$commands{$keyword}} ) ; 

	next ;

}
my %common ;
my %variable_list  ;
my @line_list ;
my @dealloc_line ;
my @alloc_line ;

my @paper ;
my $my_vari_type ;

open( F_ALLOC, ">alloc_lines.f" )  || die ; 

foreach $in_file ( @my_in_files ) 
{
    print " text: >$out_file< lit: >$in_file< style: >$out_style< \n" ;
    $out_file = $out_dir . "/" . $in_file ;
    %common = () ;
    %variable_list = () ;
    @line_list = () ;
    @dealloc_line = () ;
    @alloc_line = () ;
    
    @paper = () ;
    $my_vari_type = "";

    @paper = read_file ( $in_file ) ;

    rebuild_common ( @paper ) ;
    delete  $variable_list{""} ;
    write_file ( $out_file, @paper ) ;

}
close ( F_ALLOC ) ;
exit ;

sub read_file
{  
    my $file_name = $_[0] ; my $new_line ; 
    my @whole_file = () ;
    my $line ; 
    open ( TXT, $file_name ) || die "FILE OPEN ERROR: >$file_name< \n" ; 
#    print " read para_file: >$file_name<\n" ;
    my $np_line = 0 ;
    while(<TXT>)
    {
	chomp ;
	$line = $_ ;
	$np_line++ ;
	push ( @whole_file, $line );
    }

    print " read file:done  >$file_name< records: $np_line\n" ;
    close ( TXT ) ;
    return ( @whole_file ) ;
}

sub rebuild_common
{
    my @in_file = @_ ;
    my @v_list ;
    my $fl_line_kind ;
    my $n_label ; my $lab ; my $lab_in; my $common_name ;
    my $to_line ;
    my $n_line ;
    my @line_kind = () ;

    $n_line = 0 ;
    $fl_line_kind = "FALSE" ;
    foreach $line ( @in_file )
    {
#	print " +++++++++++++++++++ MY LINE:", $line, "\n" ;
	$n_line++ ;
	@{$line_list{$n_line}} = () ;
	$nc = length($line) ;
	if ( $nc <= 0 ) 
	{
	    $fl_line_kind = "NONE" ;
	    $line_kind{$n_line} = $fl_line_kind ;
	    next ;
	}
	@in_line = split("", $line ) ;

	if ( lc($in_line[0]) eq 'c' || $in_line[0] eq '!' ) 
	{ 
	    $fl_line_kind = "COMMENT" ;
	    $line_kind{$n_line} = $fl_line_kind ;
	    next ;
	}
	if ( lc($in_line[0]) eq '#' ) 
	{ 
	    $fl_line_kind = "PREPROC" ;
	    $line_kind{$n_line} = $fl_line_kind ;
	    next ;
	}

#	print " NEXT:", $line, "\n" ;

	my $chr_tab = -1 ; my $chr_numb = 0 ; my $I ; my $chr_test ;
	my $fl_continue="FALSE" ;


	for ( $I = 0; $I < 8 && $I < $nc ; $I++ )
	{
	    $chr_test = $in_line[$I] ;
	    if ( $chr_test eq "\t" ) 
	    { 
		$chr_tab = $I ;
	    }
	    elsif ( $chr_test =~ m"[0-9]" ) 
	    { 
		$chr_numb++;
		if ( $chr_tab > -1 )
		{
		    if ( $I > $chr_tab ) { $fl_continue = "TRUE" ; }
		}
		else
		{
#		    print " it is a number before ATB {$I} \n" ;
		    if ( $I >= 5 && $chr_numb == 1 ) { $fl_continue = "TRUE" ; }
		}
	    }
	    elsif ( $chr_test =~ m"[*\$]" ) 
	    {
		$fl_continue = "TRUE" ;
	    }
	    elsif ( $chr_test =~ m"[a-zA-Z]" ) 
	    {
		last ;
	    }
	}

	$my_line = substr($line, $I,$nc-$I ) ;
#	$my_line =~ s/ //g ;

	if ( $fl_continue eq "TRUE" ) 
	{ 
#	    print " cont:: {", $fl_continue, ":", $fl_line_kind, "}  ", $my_line, "\n" ; 
	    if ( $fl_line_kind eq "COMMON" )
	    {
		$my_line =~ s/ //g ;
		@v_list = split (",", $my_line ) ;
		push(@{$common{$common_name}{"VARIS"}}, @v_list );
#		print " $common_name varis :: {", join(" + ", @{$common{$common_name}{"VARIS"}}), "}\n" ;
		
		foreach $vari (@v_list)
		{
		    if ( exists ( $variable_list{$vari} ) )
		    {
			print "variable {$vari} already in use in common:", 
			$variable_list{$vari}{"COMMON"}, ":\n"
		    }
		    else
		    {
			$variable_list{$vari}{"COMMON"} = $common_name ;
			$variable_list{$vari}{"LINE"} = -20 ;
		    }
		}
	    }
	    elsif  ( $fl_line_kind eq "NONE" ) { print "variable {$vari} KOND = NONE \n", }
	    else
	    {
		get_varis ( $my_line, $n_line, $fl_line_kind, 0 ) ;
	    }
	}
#	print " FL_CONTINU: {$fl_continue} \[", substr($my_line,0,6), "\]\n" ;
	if ( $fl_continue ne "TRUE" ) 
	{

	if ( lc(substr($my_line,0,6) ) =~ "common" )
	{
	    $fl_line_kind = "COMMON" ;
	    my @c_names = split ( '/', $my_line ) ;
	    $common_name = $c_names[1] ;
#	    print " next common:: {", $c_names[1], "}\n" ;
	    $common{$common_name}{"NAME"} = "DONE" ;
#	    print "varis ori {", $c_names[2], "}\n" ;
	    $c_names[2] =~ s/ //g ;
#	    print "varis sub {", $c_names[2], "}\n" ;
	    @v_list = split (",", $c_names[2] ) ;
	    @{$common{$common_name}{"VARIS"}} = @v_list ;
#	    print " $common_name varis :: {", join(" + ", @v_list), "}\n" ;

	    foreach $vari (@v_list)
	    {
		if ( exists ( $variable_list{$vari} ) )
		{
		    print "variable {$vari} already in use in common:", 
		    $variable_list{$vari}{"COMMON"}, ":\n"
		}
		else
		{
		    $variable_list{$vari}{"COMMON"} = $common_name ;
		    @{$variable_list{$vari}{"DIMENS"}} = ( "SCALAR" ) ;
		    $variable_list{$vari}{"LINE"} = -10 ;
		    $variable_list{$vari}{"KIND"} = "UNKNOWN" ;
		}
	    }
	}
	elsif ( lc(substr($my_line,0,7)) =~ "integer" )
	{
	    $fl_line_kind = "INTEGER" ;
	    $my_vari_type = "";
#	    print " FOUND AN INTEGER\n" ;
	    get_varis ( $my_line, $n_line, $fl_line_kind, 7 ) ;
	}
	elsif ( lc(substr($my_line,0,9)) =~ "parameter" )
	{
	    $fl_line_kind = "PARAMETER" ;
	}
	elsif ( lc(substr($my_line,0,4)) =~ "real" )
	{
	    $fl_line_kind = "REAL" ;
	    $my_vari_type = "";
	    get_varis ( $my_line, $n_line, $fl_line_kind, 4 ) ;
	}
	elsif ( lc(substr($my_line,0,7)) =~ "complex" )
	{
	    $fl_line_kind = "COMPLEX" ;
	    $my_vari_type = "";
	    get_varis ( $my_line, $n_line, $fl_line_kind, 7 ) ;
	}
	elsif ( lc(substr($my_line,0,4)) =~ "data" )
	{
	    $fl_line_kind = "DATA" ;
	    $line_kind{$n_line} = $fl_line_kind ;
	}
	elsif ( lc(substr($my_line,0,7)) =~ "logical" )
	{
	    $fl_line_kind = "LOGICAL" ;
	    $my_vari_type = "";
	    get_varis ( $my_line, $n_line, $fl_line_kind, 7 ) ;
	}
	elsif ( lc(substr($my_line,0,10)) =~ "character" )
	{
	    $fl_line_kind = "CHARACTER" ;
	    $my_vari_type = "";
	    get_varis ( $my_line, $n_line, $fl_line_kind, 9 ) ;
	}
	else
	{
	    print " UN KNOWN LINE TYPE\n" ;
	}
	}
	$line_kind{$n_line} = $fl_line_kind ;
	
    }

#    foreach $line ( @in_file )
#    {
#    }
}

sub get_varis
{
    my ($my_line, $n_line, $fl_line_kind, $ISTART) = @_ ;
    if ( $fl_line_kind eq "PARAMETER" ) { return; }
    if ( $fl_line_kind eq "DATA" ) { return; }


    my @my_chrs = split("", $my_line) ;

    my $my_vari ; my $my_dim ;
    print "  toP === $ISTART - ",length($my_line), "-", $my_line, " \n" ;
    if ( $my_chrs[$ISTART] eq "*" ) 
    { 
	$my_vari_type = "" ;
	while ( $ISTART < @my_chrs -1 && $my_chrs[$ISTART] ne " " ) 
	{
	    $ISTART++ ; 
#	    print "  in === $ISTART - {", $my_chrs[$ISTART], "} \n" ;
	    $my_vari_type = $my_vari_type . $my_chrs[$ISTART] ;
	}
#	$ISTART++ ; 
    }
    my @word = () ;
    my $fl_dimension = "FALSE" ;
#    print " $ISTART - ",length($my_line), " \n" ;

    for ( $I=$ISTART; $I < length($my_line); $I++ )
    {
	$chr = $my_chrs[$I] ;
	if ( $chr eq " " ) 
	{ }
	elsif ( $chr =~ m"[0-9a-zA-Z_]" ) 
	{ 
#		    print " PUSH $chr \n"; 
	    push ( @word, $chr ) ; 
	}
	elsif ( $chr eq "\(" ) 
	{ 
	    print " new vari {", join( "", @word ) , "} = ";
	    $my_vari = join("", @word) ;
	    $variable_list{$my_vari}{"KIND"} = $fl_line_kind ;
	    $variable_list{$my_vari}{"TYPE"} = $my_vari_type ;
	    @{$variable_list{$my_vari}{"DIMENS"}} = () ;
	    $variable_list{$my_vari}{"LINE"} = $n_line ;
	    push(@{$line_list{$n_line}}, $my_vari ) ;
	    $fl_dimension = "TRUE" ;
	    @word = () ;
	}
	elsif ( $chr eq "\)" ) 
	{ 
	    if ( $my_vari =~ "bsum" ) 
	    { print "- zaklepaj ---->>  dimension {", join( "", @word ) , "}\n";}
	    $my_dim = join("", @word) ;
	    push (@{$variable_list{$my_vari}{"DIMENS"}}, $my_dim ) ;
#	    print "TEST: {", @{$variable_list{$my_vari}{"DIMENS"}}, "} end of\n" ;
	    $fl_dimension = "FALSE" ;
	    @word = () ;
	}
	elsif ( $chr eq "," ) 
	{ 
	    if ( $fl_dimension eq "TRUE" )
	    { 
		print "dimension {", join( "", @word ), "} x " ; 
		$my_dim = join("", @word) ;
		push( @{$variable_list{$my_vari}{"DIMENS"}}, $my_dim ) ;
	    }
	    else
	    { 
		if ( @word > 0 ) 
		{
		print "next SCALAR vari  {", join( "", @word ), "}\n" ; 
		$my_vari = join("", @word) ;
		$variable_list{$my_vari}{"KIND"} = $fl_line_kind ;
		$variable_list{$my_vari}{"LINE"} = $n_line ;
		$variable_list{$my_vari}{"TYPE"} = $my_vari_type ;
		push(@{$line_list{$n_line}}, $my_vari ) ;
		@{$variable_list{$my_vari}{"DIMENS"}} = ( "SCALAR" ) ;
		}
	    }
	    @word = () ;
	}
	else
	{
	    print "ELSE-------: $chr $my_vari\n" ;
	}
	
    }
    if ( scalar (@word) > 0 )
    {
	print "last SCALAR vari  {", join( "", @word ), "}\n" ; 
	$my_vari = join("", @word) ;
	$variable_list{$my_vari}{"KIND"} = $fl_line_kind ;
	$variable_list{$my_vari}{"LINE"} = $n_line ;
	$variable_list{$my_vari}{"TYPE"} = $my_vari_type ;
	push(@{$line_list{$n_line}}, $my_vari ) ;
	@{$variable_list{$my_vari}{"DIMENS"}} = ( "SCALAR" ) ;
    }    
}

sub get_params
{
    my ($my_line, $fl_line_kind, $ISTART) = @_ ;

    my @my_chrs = split("", $my_line) ;

    if ( $my_chrs[$ISTART] eq "*" ) { $ISTART++ ; $ISTART++ ; }
    my @word = () ;
    my $fl_dimension = "FALSE" ;
    for ( $I=$ISTART; $I < length($my_line); $I++ )
    {
	$chr = $my_chrs[$I] ;
	if ( $chr =~ m"[0-9a-zA-Z_]" ) 
	{ 
#		    print " PUSH $chr \n"; 
	    push ( @word, $chr ) ; 
	}
	elsif ( $chr eq "\(" ) 
	{ 
	    print " new vari {", join( "", @word ) , "} = ";
	    $fl_dimension = "TRUE" ;
	    @word = () ;
	}
	elsif ( $chr eq "\)" ) 
	{ 
	    print "dimension {", join( "", @word ) , "}\n";
	    $fl_dimension = "FALSE" ;
	    @word = () ;
	}
	elsif ( $chr eq "," ) 
	{ 
	    if ( $fl_dimension eq "TRUE" )
	    { print "dimension {", join( "", @word ), "} x " ; }
	    else
	    { 
		# print "next vari {", join( "", @word ), "}\n" ; 
	    }
	    @word = () ;
	}
	else
	{
	    print "ELSE: $chr \n" ;
	}
	
    }
}

sub write_file
{
    use FileHandle ;
    my $file_name = shift ; 
    my @text_file = @_ ;
    my $cmn ;
    my $vari ;
    my $line ;
    my $dmn ;
    print " output file nmame -------------------", $file_name, "\n" ;

    open ( TXT, "> $file_name" ) || die "FILE OPEN ERROR: >$file_name< \n" ; 
    my $nn = 0 ;

	foreach $dmn ( keys (%variable_list) )
	{
	    print " PRINT dmn <$dmn>:{", @{$variable_list{$dmn}{"DIMENS"}}, "}\n";
	}

    foreach $cmn ( keys (%common) )
    {
	$nn = 0 ;
	$line = join( "", "C\tcommon /", $cmn, "/" ) ;
	push( @dealloc_line, $line ) ;
	push( @alloc_line, $line ) ;
	print " common /", $cmn, "/\n" ;
#	print " PRINT common {$cmn} BSUMM2:{", @{$variable_list{"bsumm2"}{"DIMENS"}}, "}\n";
	foreach $vari ( @{$common{$cmn}{"VARIS"}} )
	{
#	    if ( scalar(@{$variable_list{$vari}{"DIMENS"}}) == 1 ) 
#	    {$dmn = ${$variable_list{$vari}{"DIMENS"}}[0] ;}
#	    else
	    {$dmn = join(",", @{$variable_list{$vari}{"DIMENS"}} ) ;}
	    print "VARI<", $vari,"> dimensions: {", $dmn, "}\n" ;
	    if ( $dmn eq "SCALAR" )
	    {
#	    print " vari:", $variable_list{$vari}{"KIND"}, " :",  $variable_list{$vari}{"TYPE"}, ": ", $vari, "\n" ;
	    }
	    else
	    {
		
#	allocate ( isrvec(3,NSRFMX), stat = istate )
#    	deallocate( isrvec, stat = istate)
		
#	    print " vari:", $variable_list{$vari}{"KIND"}, " :",  $variable_list{$vari}{"TYPE"}, ": ", $vari, "\[", 
#	    $dmn, "\]\n" ;
		my $fl_on = "FALSE" ;
		my $prm ;
		foreach $prm ( @params ) { if (  $dmn =~ $prm ) { $fl_on = "TRUE" ; } }
#	       print "FL ON TEST ", $fl_on, " ", $dmn, "\n" ;
		if ( $fl_on eq "TRUE" ) 
		{
		    $nn++ ;
		    
		    $line = join( "", "\tdeallocate \( ", $vari, ", stat = istate \)" ) ;
		    push( @dealloc_line, $line ) ;
		    $line = join( "", "\tallocate \( ", $vari, "\(", $dmn, "\), stat = istate \)" ) ;
		    push( @alloc_line, $line ) ;
		    
#	    print "deallocate \( ", $vari, ", stat = istate \)\n" ;
#	    print "allocate \( ", $vari, "\(", $dmn, "\), stat = istate \)\n" ;
		}
	    }
	}
	if ( $nn == 0 ) 
	{
	    shift ( @dealloc_line ) ;
	    shift ( @alloc_line ) ;
	}
	else
	{
	    push( @dealloc_line, "" ) ;
	    push( @alloc_line, "" ) ;
	}
    }
#    exit ;
## #     open( TXT, ">$file_name" )  || die ; 
## # #    my $TXT = new FileHandle ( "> $file_name" )  || die ; 
## #     my $prg ;
    my $n_line ; my $fl_line_kind ;
    foreach $prg ( @text_file ) 
    {
	$n_line++ ;
	$fl_line_kind = $line_kind{$n_line} ;
	if ( scalar( @{$line_list{$n_line}}) > 0 )
	{
#	    print "YES VARI:", $fl_line_kind, "::", $prg, "\n" ;
	    foreach $vari ( keys (%variable_list ) )
	    {
#		if (  $variable_list{$vari}{"LINE"} == -10 ) { print "which -10 VARI:", $fl_line_kind, "::", $vari, " - ", $n_line, "\n" ; }
#		if (  $variable_list{$vari}{"LINE"} == -20 ) { print "which -20 VARI:", $fl_line_kind, "::", $vari, " - ", $n_line, "\n" ; }
		if ( $variable_list{$vari}{"LINE"} == $n_line )
		{
		    $dmn = join(",", @{$variable_list{$vari}{"DIMENS"}}) ;
		    my $fl_on = "FALSE" ;
		    my $prm ;
		    foreach $prm ( @params ) { if (  $dmn =~ $prm ) { $fl_on = "TRUE" ; } }
#	       print "FL ON TEST ", $fl_on, " ", $dmn, "\n" ;
		    if ( $fl_on eq "TRUE" ) 
		    {
			my $dmn_class = ":" ; 
			my $I ;
			for ($I= 1; $I< scalar ( @{$variable_list{$vari}{"DIMENS"}}) ; $I++ ) { $dmn_class = $dmn_class . ",:" ; };
			print TXT "\t", lc($variable_list{$vari}{"KIND"}), "*", $variable_list{$vari}{"TYPE"}, 
			", pointer :: ",  $vari, "\(", $dmn_class, "\)\n" ;
			
		    }
		    else
		    {
			my @out_line = () ;
			if ( $dmn eq "SCALAR" )

			{
#		       print " vari:", $variable_list{$vari}{"KIND"}, " :",  $variable_list{$vari}{"TYPE"}, ": <", $vari, ">\n" ;
			    push( @out_line, "\t" ) ;
			    push( @out_line, lc($variable_list{$vari}{"KIND"}) ) ;
			    if ( exists ( $variable_list{$vari}{"TYPE"}) ) 
				 { if ( $variable_list{$vari}{"TYPE"} ne "" ) 
				   { push( @out_line, "*",  $variable_list{$vari}{"TYPE"}) ; }
				 }
				
			    push( @out_line, " " ) ;
			    push (@out_line, $vari, "\n" ) ;
			    print join ("", @out_line) ;
			    print TXT join ("", @out_line) ;
#			    print TXT "\t", lc($variable_list{$vari}{"KIND"}), "*",  $variable_list{$vari}{"TYPE"}, " ", $vari, "\n" ;
			    if ( lc($variable_list{$vari}{"KIND"}) =~ "logical" ) 
			    { print " SCALAR-logical:::>",$variable_list{$vari}{"KIND"}, "<\n" ; } 
			}
			else
			{
#			    print " vari:", $variable_list{$vari}{"KIND"}, " :",  $variable_list{$vari}{"TYPE"}, ": ", $vari, "\[", 
#			    $dmn, "\]\n" ;
			    if ( lc($variable_list{$vari}{"KIND"}) =~ "logical" ) 
			    { print " ARRAY-logical:::>",$variable_list{$vari}{"KIND"}, "<\n" ; } 

			    push( @out_line, "\t" ) ;
			    push( @out_line, lc($variable_list{$vari}{"KIND"}) ) ;
			    if ( exists ( $variable_list{$vari}{"TYPE"}) ) 
				 { if ( $variable_list{$vari}{"TYPE"} ne "" ) 
				   { push( @out_line, "*",  $variable_list{$vari}{"TYPE"}) ; }
				 }
				
			    push( @out_line, " " ) ;
			    push (@out_line, $vari, "\(",  $dmn, "\)\n" ) ;
			    print join ("", @out_line) ;
			    print TXT join ("", @out_line) ;

#			    print TXT "\t", 
#			    lc($variable_list{$vari}{"KIND"}), "*",  
#			    $variable_list{$vari}{"TYPE"}, " ", $vari, "\(", 
#			    $dmn, "\)\n" ;
			}
		    }
		}
	    }
	}
	else
	{
#	    print " no VARI:", $fl_line_kind, "::", $prg, "\n" ;
	    print TXT $prg, "\n" ;
	}
## # 	print TXT $prg, "\n" ;
	
    }
    close ( TXT ) ;
## #     close (TXT) ;
#    print "DEALLOCATE \n" ;
    
    foreach $line ( @dealloc_line ) 
    {
	print F_ALLOC $line, "\n" ;
    }
    
#    print "ALLOCATE \n" ;
    foreach $line ( @alloc_line ) 
    {
	print F_ALLOC $line, "\n" ;
    }
#    print "end DE ALLOCATE \n" ;
    
    foreach $vari ( keys (%variable_list ) )
    {
	if (  $variable_list{$vari}{"LINE"} < -1 ) { print "which VARI:", $fl_line_kind, "::", $vari, " - ", $n_line, "\n" ; }
    }
}


sub get_commands
{
    my $key = "" ;
    my $word ;
    my %c_line = () ;
    my @arg_char = () ;
    foreach $word ( @_ )
    {
	@arg_char = split( '', $word ) ;
#	print "word: $word \n" ; 
	if ( length($word) <= 0 ) { next ; }
	if ( $word !~ m"[a-zA-F]" ) { } #print "word: $word is a number\n" ; }
	else 
	{ 
#	    print "word: $word is a NON-number\n" ; 

	    if ( $arg_char[0] eq '-' ) 
	    {
		if ( $arg_char[1] eq "-" ) 
		{
		    my $num = scalar(@arg_char) - 1;
		    $key = join ( "", @arg_char[2 .. $num] );
		    push ( @{$c_line{$key}}, ' ' ) ; 
		}
		else
		{
		    $key = $arg_char[1] ; 
		    push ( @{$c_line{$key}}, ' ' ) ; 
		}
		next ;
	    }
	}

	if ( $key ne '' ) 
	{ 
	    $key = lc ( $key ) ; 
#	print "$key: \n" ;
	    my $tmp = join ( '', @{$c_line{$key}} ) ; 
	    if ( $tmp eq ' ' ) { delete $c_line{$key} ; }
	    push ( @{$c_line{$key}}, $word ); 
	}
    }
    return ( %c_line ) ;
}


