	program fftmap
	implicit none
	integer*4 nbmaps, nrlmax
	parameter (nbmaps=8000000)
	parameter ( nrlmax=400000 )
	real*4 CELL(6)
	INTEGER*4 MIFD(9), IPERM(3), ind(3), irev(3)
	integer*4 nabc(3), iorig(3), mxyz(3), igrid(3),
     * nlayer, ilay, i, j, nn, ndens, iok, leng, ires
	real*4 rlayer(nrlmax), rmin, rmax, sigma, delta
	real*8 dsum
	character*132 line
c	character*1 bmaps(nbmaps)
	real*4 bmaps(nbmaps)
	character*1 bln(80)
c
	integer*4 iu, i1, i2, i3, i4, i5, ii, k1, k2, k3, iln

99	format( 80a1 )

990	continue
	iu = 1
	write(*,*) ' INPUT FFT DENSITY FILE NAME:'
	read(*,99,err=900) (line(j:j),j=1,80)
	open ( unit = iu, file = line, carriagecontrol='list',
     * form='unformatted',recl=2044, status = 'old', err = 990 )

	nlayer = 0
	read(iu)line(1:80)

	read(iu)ii, i2, i3, i4, i5
	iorig(2) = ii
	mxyz(1) = i3+1
	iorig(1) = i2
	mxyz(3) = i5+1
	iorig(3) = i4
	if ( ii .eq. -1 ) stop ' FFT -1'
	nn = 0
3	continue
	nlayer = nlayer + 1
	ilay = (i3+1)*(i5+1) 
	if ( ilay .gt. nrlmax ) stop ' LAYER TOO LARGE'
	read(iu) (rlayer(i), i=1, ilay)
	ndens = 0

	k2 = ii
	do 2 k3 = 0, mxyz(3)-1
	do 2 k1 = 0, mxyz(1)-1
c	nn = k1 + k2*mxyz(1) + k3*mxyz(1)*mxyz(2) +1
	ndens = ndens + 1
	nn = nn + 1
	bmaps(nn) = rlayer(ndens)	
2	continue

	read(1,end=1)ii, i2, i3, i4, i5
	if ( ii .eq. -1 ) goto 1
	goto 3
1	continue
	mxyz(2) = nlayer

	nn = mxyz(1) * mxyz(2) * mxyz(3)
	dsum = 0.0
	rmin = 9999.0
	rmax = -9999.0
	do 4 i = 1, nn 
	if ( bmaps(i) .lt. rmin ) rmin = bmaps(i)
	if ( bmaps(i) .gt. rmax ) rmax = bmaps(i)
4	dsum = dsum + bmaps(i)*bmaps(i)
	sigma = 1. / dsqrt(dsum/ (dfloat(nn)))

	write(*,*) ' befou:', rmin, rmax, 1. / sigma
	delta = (rmax-rmin)/ 255. 
c
980	continue

	write(*,*) ' OUTPUT MAIN FILE NAME:'
	read(*,99,err=900) (line(j:j),j=1,80)
	if ( line(1:2) .eq. '-1' ) goto 2
	ires = 2
	open ( unit = ires, file = line, status = 'new',
     * carriagecontrol = 'list', err = 900 )

	write(*,*) ' CELL CONSTANTS::'
	call rdline ( iok, 5, line, leng, 0 )
	if ( iok .gt. 0 ) goto 100
	if ( iok .lt. 0 ) goto 102
	if ( leng .le. 0 ) goto 101
c	call wrline ( iok, iout, line, leng, 1 )
	read(line(1:leng), '(6f)',err=104) cell
	write(*,*) ' NUMBER OF GRIDS PER UNIT CELL::'
	call rdline ( iok, 5, line, leng, 0 )
	if ( iok .gt. 0 ) goto 100
	if ( iok .lt. 0 ) goto 102
	if ( leng .le. 0 ) goto 101
c	call wrline ( iok, iout, line, leng, 1 )
	read(line(1:leng),'(3i)',err=104) igrid
c
c
12	format( 6e12.5 )
111	format( 10i5 )
	write(ires,12) cell
	write(ires, 111) igrid, iorig, mxyz, 0
	write(ires,12) rmin, rmax, 0.0
	iln = 0
	do 20 k3 = 0, mxyz(3)-1
	do 20 k2 = 0, mxyz(2)-1
	do 20 k1 = 0, mxyz(1)-1
c
c	write(ires, '(20a4)', err=104) (bmaps(j)*sigma, j=1, nn)
	nn = k1 + k3*mxyz(1) + k2*mxyz(1)*mxyz(3) + 1
	iln = iln + 1
	bln(iln) = char(int ((bmaps(nn) - rmin ) / delta))
	if ( iln .ge. 80 ) then
	write(ires, '(80a1)') bln
	iln = 0
	end if
20	continue
	write(ires, '(80a1)') (bln(i), i=1, iln)
	iln = 0

	stop 'O.K.'
100	write (*,*) ' RD_MAP> ERROR: READING MAP FILE TITLE '
	stop
101	write (*,*) ' RD_MAP> ERROR: EMPTY LINE'
	stop
102	write ( *,* ) ' RD_MAP> END OF FILE DETECTED'
	stop
103	write ( *,* ) ' RD_MAP> NUMBER OF POINTS OVER BOUNDRIES'
	stop
104	write ( *,* ) ' RD_MAP> ERROR: WRITING MAP FILE'
	stop
900	stop ' FILE OPEN ERROR'
	end
C
c
c ----------------------------------------
c
c writes a line of text to unit iu
c
	subroutine wrline ( iok, iun, line, leng, level )
	character*132line
	iok = 0
	write ( iun, 1, err=100 ) (line(j:j),j=1,leng)
1	format( 132a1 )
	return
100	continue
	iok = 1
	return
	end
c
c ----------------------------------------
c
c reads a line of text from unit iu
c
	subroutine rdline ( iok, iu, line, leng, level )
	character*132 line
	leng = 0
	iok = 0
	read ( iu, 1, end=200, err=100 ) (line(j:j),j=1,132)
1	format( 132a1 )
	do 2 i = 132,1,-1
	if ( line(i:i) .eq. ' ' ) goto 2
	leng = i
	return
2	continue
	return
c error
100	continue
	iok = 1
	return
c end of file
200	continue
	iok = -1
	return
	end
c
c
	subroutine putlay ( nlayer, iorig, mxyz, rlayer, nn )
	integer*4 iorig(3), mxyz(3)
	real*4 rlayer(1000000)
c
c	write(*,*) nlayer, iorig, mxyz, nn
	write(1)nlayer, iorig(1), (iorig(1)+mxyz(1)-1),
     * iorig(3), (iorig(3)+mxyz(3)-1)
	write(1) (rlayer(j), j=1, nn )
	return
	end	
c
