#!/usr/bin/perl -w
use strict;
use lib $ENV{ 'MAIN_CONF'}  ;
use main_config ;
my %commands = () ;

if ( @ARGV <= 0 ) { push ( @{$commands{'help'}}, ' ' ) ; } 
else { (%commands) = main_config::get_commands ( @ARGV ) ; }

#####################################################################

my $HTML_FILE = "a.html" ;
my $SOURCE_FILE = "a.txt" ;
my $TOC_FILE = "a.toc_html" ;
my $IND_FILE = "a.ind_html" ;
my $TOC_PATH = "./" ;
my $IND_PATH = "./" ;
my $MODE = "TEXT" ;
my $PROC_ERROR = "FALSE" ;
my $doit = "FALSE" ;

my $keyword ; 
foreach $keyword ( sort keys (%commands) ) 
{
#    print " $keyword \n" ;
    if ( $keyword eq 'h' || substr($keyword, 0,4) eq "help"   ) { goto HELP }
    if ( $keyword eq 'o' || substr($keyword, 0,6) eq "output" ) { goto OUTPUT }
    if ( $keyword eq 's' || substr($keyword, 0,6) eq "source" ) { goto SOURCE }
    if ( $keyword eq 't' || substr($keyword, 0,3) eq "toc"  ) { goto TOC }
    if ( $keyword eq 'm' || substr($keyword, 0,5) eq "mode"   ) { goto MODE }
    if ( $keyword eq 'x' || substr($keyword, 0,5) eq "index"   ) { goto IND }
    if ( $keyword eq 'p' || substr($keyword, 0,4) eq "path" ) { goto PATH }
    if ( $keyword eq 'q' || substr($keyword, 0,6) eq "q_path"  ) { goto Q_PATH }
    if ( substr($keyword, 0,4) eq "doit" ) { $doit = "TRUE" ; next ; }
    print "unknown option >$keyword<\n" ; $PROC_ERROR = "TRUE" ;

  HELP: 
    print 
	"  -h|--help)    prints this message with available options and current status \n",
	"  -s|--source)  source text file [$SOURCE_FILE]\n", 
	"  -o|--output)  basic html file [$HTML_FILE]\n", 
	"  -m|--mode)    mode [TEXT/HELP] [$MODE]\n",
	"  -t|--toc)     table of contents file [$TOC_FILE]\n",
	"  -p|--path)    table of contents file path [$TOC_PATH]\n",
	"  -q|--q_path)  index file path [$IND_PATH]\n",
	"  -x|--index)   keyword index file [$IND_FILE]\n",
	"     --doit)    create the output\n" ;
    exit ;
#	"  -p|--path)    path of TOC file [$TOC_PATH]\n",
#	"  -q|--q_path)  path of IND file [$IND_PATH]\n",
  OUTPUT:  $HTML_FILE = shift ( @{$commands{$keyword}} ) ; next ;
  SOURCE:  $SOURCE_FILE = shift ( @{$commands{$keyword}} ) ; next ;
     TOC:  $TOC_FILE = shift ( @{$commands{$keyword}} ) ; next ;
     IND:  $IND_FILE = shift ( @{$commands{$keyword}} ) ; next ;
    MODE:  $MODE = shift ( @{$commands{$keyword}} ) ; next ;
    PATH:  $TOC_PATH = shift ( @{$commands{$keyword}} ) ; next ;
  Q_PATH:  $IND_PATH = shift ( @{$commands{$keyword}} ) ; next ;

}
# print " proc error $PROC_ERROR \n" ;
# print " doit  $doit\n" ;
if ( $PROC_ERROR eq "TRUE"  ) { exit ; }

#######################################

if ( $doit eq "FALSE" )  { exit ; }

######################################

print " files: $SOURCE_FILE > $HTML_FILE, $TOC_FILE, $IND_FILE \n" ;

open ( TEXT,  "< $SOURCE_FILE" ) || die "FILE OPEN ERROR: >$SOURCE_FILE< \n" ;

######################################

# $x = length($record); printf ( "$x \n");
my @whole_file = () ;
@whole_file = ( <TEXT> ) ;
close ( TEXT ) ;

my $line ;
my $nc ;
my $II = 0;
my @line_point_to = () ;
my @line_point_from = () ;
my @line_length = () ;
my @line_par = () ;
my @file_lines = () ;
my @verbatim_lines = () ;
foreach $line (@whole_file)
{
    chomp ( $line ) ;
    $II++ ;
    my $leng = length ( $line ) ;
    $line_point_to[$II-1] = $II  ;
    $line_point_from[$II] = $II - 1 ;
    push( @file_lines, $line ) ;
}

my $last_pointer = $II-1 ;
my $last_line = $II ;
my $last_text_line = $II ;
my $nlines = $II ;
my $first_pointer = 0 ;

$line_point_from[0] = -1 ;
$line_point_from[$first_pointer] = -1 ;
$line_point_to[$last_pointer] = -1  ;

print " main> 0 first last: $first_pointer, $last_pointer\n" ;

&insert_line( '<html>', 0 ) ;
#print " main> 1 first last: $first_pointer, $last_pointer\n" ;
&append_line( '<head bgcolor="#000000">', $first_pointer ) ;
&append_line( '<title>', $nlines ) ;
if ( $MODE eq "TEXT" )
{ &append_line( 'MAIN User`s Guide:', $nlines ) ; }
elsif ( $MODE eq "HELP" )
{ &append_line( 'MAIN Reference Manuals:', $nlines ) ; }
&append_line( '</title>', $nlines ) ;
&append_line( '</head>', $nlines ) ;
&append_line( '<body bgcolor="#000000">', $nlines ) ;

&append_line( '</body>', $last_pointer ) ;
&append_line( '</html>', $last_pointer ) ;
#&exclude_line( 5 ) ;
#&exclude_line( 4 ) ;
#&exclude_line( 6 ) ;
#&insert_line( '<third line>', 3 ) ;

my $nn ;
my $ifr ;

&insert_paragraphs () ;

&insert_verbatims () ;

# scpecials chars - escapes

&insert_misc_chars () ;
# check the "s

&check_apostrophes () ;


&write_file_lines() ;

exit ;

# insert paragraphs

sub insert_paragraphs
{
    $ifr = -1 ;
    my $n_par = 0 ;
    my $nn ;
    my $ii ;
#    $line_par[0..$last_text_line] = -1 ;
    for ( $nn = 0; $nn < $last_text_line ; $nn++ )
    {
	if ( $line_point_to[$nn] < 0 ) { next ; }
	if ( length( $file_lines[$nn]) == 0 && length( $file_lines[ $line_point_to[$nn]]) > 0 )
	{ 
	    $ifr = $nn ; 
	    $n_par++ ;
	}

	if ( length( $file_lines[$nn]) > 0 && length( $file_lines[ $line_point_to[$nn]]) == 0 )
	{ 
	    if ( $ifr > 0 ) 
	    {
		&append_line( '<p>', $ifr ) ; 
		&append_line( '</p>', $nn ) ; 
		print " new paragraph $ifr to $nn \n" ;
		for ( $ii = $ifr+1; $ii <= $nn ; $ii++ ) 
		{ 
		    $line_par[$ii] = $n_par ;
		}
		$ifr = -1 ;
	    }
	}
    }
#last paragraph
    if ( $ifr > 0 ) 
    {
	&append_line( '<p>', $ifr ) ; 
	&append_line( '</p>', $nn ) ; 
	for ( $ii = $ifr+1; $ii <= $nn ; $ii++ ) 
	{ 
	    $line_par[$ii] = $n_par ;
	}
    }

    for ( $nn = 0; $nn < $last_text_line ; $nn++ )
    { 
	if ( defined( $line_par[$nn] ) )
	{ print "$nn is =  defined $line_par[$nn] >", $file_lines[$nn], "\n" ; }
	else
	{ print "$nn not !== defined >", $file_lines[$nn], "\n" ; }
    }
}

# insert verbatims

sub insert_verbatims
{

    $ifr = -1 ;
    for ( $nn = 0; $nn < $last_text_line ; $nn++ )
    {
	if ( $line_point_to[$nn] < 0 ) { next ; }
	if (  substr($file_lines[$nn], 0,1) eq "\$" ||
	      substr($file_lines[$nn], 0,1) eq ">" ||
	      substr($file_lines[$nn], 0,3) eq "..." ||
	      substr($file_lines[$nn], 0,5) eq "MAIN>" ||
	      substr($file_lines[$nn], 0,1) eq "*" ||
	      substr($file_lines[$nn], 0,1) eq " " ||
	      substr($file_lines[$nn], 0,1) eq "\t" ||
	      substr($file_lines[$nn-1], 0,6) eq "Syntax" )
	{
	    if ( $ifr < 0 ) { 
		$ifr = $nn ; 
		&insert_line( '<BLOCKQUOTE><PRE><FONT SIZE="-1">', $nn ) ; 
	    }
	    $verbatim_lines[$nn] = 1 ;
	}
	else
	{
	    if ( $ifr > 0 ) 
	    { 
		&append_line( '</FONT></PRE> </BLOCKQUOTE>', $nn-1 ) ; 
	    }
	    $ifr = -1 ;
	    $verbatim_lines[$nn] = 0 ;
	}
    }
}

sub insert_misc_chars
{
    my @line_chars ;

    for ( $nn = 0; $nn < $last_text_line ; $nn++ )
    {
	if ( $verbatim_lines[$nn] != 0 ) { next ; }
#	my @line_chars = split( "", $file_lines[$nn] ) ;
#	my $line = join( "", $line_chars[1..] ;
#	    print "$nn the <<<< sign }", $file_lines[$nn] ,"{\n" ;
	if ( substr($file_lines[$nn], 0,5) eq "File:" )
	{ $file_lines[$nn] = "<BR> " . $file_lines[$nn] ;
	  next ; }
	if ( substr($file_lines[$nn], 0,14) eq "Last modified:" )
	{ $file_lines[$nn] = "<BR> " . $file_lines[$nn] ;
	  next ; }

	if (  $file_lines[$nn] =~ "<" )
	{
	    @line_chars = split ("<",  $file_lines[$nn] ) ;
	    $file_lines[$nn] = join ("\&lt;", @line_chars ) ;
	}
	if (  $file_lines[$nn] =~ ">" )
	{
	    @line_chars = split (">",  $file_lines[$nn] ) ;
	    $file_lines[$nn] = join ("\&gt;", @line_chars ) ;
	}
	if (  $file_lines[$nn] =~ "<" )
	{
	    @line_chars = split ("\&",  $file_lines[$nn] ) ;
	    $file_lines[$nn] = join ("\&amp;", @line_chars ) ;
	}
    }
}

sub check_apostrophes
{
    my @line_chars ;
    my $ifr = -1 ;
    my $ipar = -1 ;
    my ( $ib, $ie, $ii ) ;

    my $ibase = -1 ;
    for ( $ii = 0; $ii < $last_text_line ; $ii++ )
    {
	if ( $verbatim_lines[$ii] != 0 ) { next ; }

	if ( !defined( $line_par[$ii]) )
	     {
		 if ( $ifr > 0 ) { &append_line( '"</STRONG>', $ibase ) ; }
		 $ifr = -1 ;
		 next ;
	     }
	if ( $line_par[$ii] != $ipar )
	{
	    $ipar =  $line_par[$ii] ;
	    if ( $ifr > 0 ) { &append_line( '"</STRONG>', $ibase ) ; }
	    $ifr = -1 ;
	}

	$ibase = $ii ;
	my @new_line ;
	if (  $file_lines[$ii] =~ '"' )
	{
	    @new_line = () ;
	    @line_chars = split (" ", $file_lines[$ii] ) ;

	    my $str ;
	    foreach $str ( @line_chars )
	    {
		$ib = -1 ;
		$ie = -1 ;
		my $lng = length( $str ) ;
		if ( $lng > 1 && substr($str, 0,1) eq '"' && substr($str, $lng-1,1) eq '"' ) 
		{
# test for file
		    print " test for file >$str<\n" ;
		    push (@new_line, '<STRONG>"') ;
		    my $file_name = $str ;
		    $file_name =~ s/"//g ;
		    if ( -e $file_name 
			 || substr( $file_name, length($file_name) - 5, 5) eq ".html"
			 || substr( $file_name, length($file_name) - 4, 4) eq ".jpg"
			 || substr( $file_name, length($file_name) - 4, 4) eq ".png"
			 || substr( $file_name, length($file_name) - 4, 4) eq ".gif"
			 || substr( $file_name, 0, 5) eq "http:"
			 || substr( $file_name, 0, 5) eq "HTTP:"
			)
		    {
			push ( @new_line, '<A HREF = "') ;
			if ( substr( $file_name, length($file_name) - 4, 4) eq ".txt" )
			{ $file_name =~ s/.txt/.html/ ; }
			push ( @new_line, $file_name) ; 
			push ( @new_line, '"> ') ;
			push ( @new_line, $file_name) ;
			push ( @new_line, '</A>') ;
		    }
		    else
		    {
			push (@new_line, $file_name) ;
		    }
		    push (@new_line, '"</STRONG> ') ;
		}
		elsif ( substr($str, 0,1) eq '"' ) 
		{
		    print " first char  >$str<\n" ;
		    $ifr = 1 ;
		    push (@new_line, ' <STRONG>') ;
		    push ( @new_line, $str, " " ) ;
		}
		elsif ( substr($str, $lng-1,1) eq '"' ) 
		{
		    print " last char  >$str<\n" ;
		    $ifr = -1 ;
		    push ( @new_line, $str, ) ;
		    push (@new_line, '</STRONG> ') ;
		}
		else
		{
		    push ( @new_line, $str, " ") ;
		}
	    }
	    $file_lines[$ii] = join ( "", @new_line ) ;
	}
    }
}
# $str = "AAABBBAAACCC";
# $count = 0;
# $count++ while ($str =~ /AAA/g);
# print "$count\n";

sub write_file_lines
{
    my $II = $first_pointer ;
    print " write> last text line: $last_text_line \n" ;
    print " write> first: $first_pointer, $file_lines[$first_pointer] \n" ;
    print " write>  last: $last_pointer, $file_lines[$last_pointer] \n" ;
    my $nn = 0 ;
    my $line ;
    foreach $line ( @file_lines)
    {
  	print " writes> $nn frm: $line_point_from[$nn] " ;
  	print "to: $line_point_to[$nn] >  ";
  	print "$file_lines[$nn]\n" ;
  	$nn++ ;
    }
# 
##     open ( TEXT,  "> $HTML_FILE" ) || die "FILE OPEN ERROR: >$HTML_FILE< \n" ;
      while ( ) 
    {
 # #	print TEXT $file_lines[$II], "\n" ;
 	print $line_point_from[$II], " $II ", $line_point_to[$II], ">>  ", $file_lines[$II], "\n" ;
  	if ( $II == $last_pointer || $II < 0 ) { last ; }
  	$II = $line_point_to[$II] ;
 # #	if ( $nn > 10 ) { last ; }
      }
##      close (TEXT ) ;
}

sub insert_line
{
    my ($string, $II ) = @_ ;

    $nlines = $#file_lines ;
#    print " start: $nlines" ;
    push ( @file_lines, $string ) ;
    $nlines = $#file_lines ;
#    print " after: $nlines \n" ;
    $line_point_from[$nlines] = $line_point_from[$II] ;

    if ( $line_point_from[$II] > 0 )
    { 
	$line_point_to[ $line_point_from[$II] ] = $nlines ; 
    }

    $line_point_to[$nlines] = $II ;
    $line_point_from[$II] = $nlines ;
    if ( $II == $first_pointer ) { $first_pointer = $nlines ; }
    $last_line = $nlines ;
#    print " inserts> frms: $line_point_from[$II], $line_point_from[$nlines] \n" ;
#    print " inserts> toos: $line_point_to[$II], $line_point_to[$nlines] \n" ;
#    print " insert_lines: $II $string $nlines $file_lines[$nlines]\n" ;
}

sub append_line
{
    my ($string, $II ) = @_ ;

    push ( @file_lines, $string ) ;
    $nlines = $#file_lines ;

    $line_point_to[$nlines] = -1  ;
    $line_point_from[$nlines] = -1  ;

#    print " append_lines: $II  $last_pointer -- $string $nlines $file_lines[$nlines]\n" ;

    $line_point_to[$nlines] = $line_point_to[$II] ;
    $line_point_to[$II] = $nlines ;

    $line_point_from[ $line_point_to[$nlines] ] = $nlines ; 
    $line_point_from[$nlines] = $II  ;

#	print " append_lin 1: $nlines = $line_point_to[$nlines] \n" ;
#	print " append_lin 2: $line_point_to[$II] = $nlines \n" ;
#    }
#    $line_point_from[$nlines] = $II ;
    if ( $II == $last_pointer ) { $last_pointer = $nlines ; }
    $last_line = $nlines ;
#    &write_file_lines () ;

}

sub exclude_line
{
    my $II = shift (@_) ;
    if ( $first_pointer == $II ) { $first_pointer =  $line_point_to[$II] ; }
    if ( $last_pointer == $II ) { $last_pointer =  $line_point_from[$II] ; }
    $line_point_to[ $line_point_from[$II] ] = $line_point_to[$II] ;
    $line_point_from[ $line_point_to[$II] ] = $line_point_from[$II] ;
    $line_point_to[$II] = -1 ;
    $line_point_from[$II] = -1 ;
}

sub gen_anchor
{
    my ( $string ) = @_ ;
    my @words = split( " ", $string ) ;
    my @anchor = () ;
    my $word ;
    foreach $word ( @words )
    {
	push ( @anchor, substr( $word, 0,1 ) );
    }
    return( join("", @anchor ) );
}
