C
C - DON'T forget to update the version number in FORMAT 2000.
c
C some changes (window size - to cut the image, backup
C of commands to a fort79 and colors by d. turk 
C
C   MPIBIO Changes:
C   - 21-Apr-90 Andi Karrer: V6.6.3
C     Made PostScript output more compact by defining macros for the
C     'moveto', 'lineto' and 'stroke' operators. Also changed coordinates
C     from F9.4 to F7.2, this is enough and saves bytes.
C     Duplicated 'ID' and 'LABEL' command into the section after label 170.
C     This is in accordance with HPPLOT, i don't know why it was not present
C     here.
C     Changed some comments that were simply wrong.
C   - 13-Feb-90 Andi Karrer: V6.6.2
C     Added option for L-R-L triple stereo plot. Whole picture must
C     be 18.3 cm wide, each picture 5.3 cm wide, and separation must be
C     6.5 cm. So we must make one pass thru the file just to get the scale.
C   - 7-Dec-89 Andi Karrer: V6.6.1
C     Bug fix: LINE was declared CHARACTER*72, but CHARACTER*80 was needed.
C     Do our own dashing. The PostScript dashing will generate dashes
C     that do not match between L- and R- stereo pairs. We now generate
C     dashes in 3D space (before projection) and ensure that begin- and
C     end-points are in pen-down mode. This leads to a somewhat varying
C     dashing. A new subroutine DASH does the dashing - only for bonds,
C     not for crosses.
C
      PROGRAM LWPLOT
C
C   PS300 FRODO version 6.6  (JSS  01-APR-1988)
C
C   Program LWPLOT is used to draw a plot on the Apple Laser writer using
C   the commands found in a FRODO plot file.  The program reads the plot
C   file containing a list atoms in the display, the viewport matrix,
C   the identifications, the translation, and slab, and the electron
C   density contours.  It then creates a POSTSCRIPT file for plotting
C   on the laser printer.
C
C   Changes for version 6.6:
C
C   1. Change file opening routine name from FOPEN to PSOPEN
C
C   Original source from PS300 FRODO version 6.3  (JSS 01-JAN-1987)
C
      PARAMETER (LUN1=1,LUN2=2,LUN5=5,LUN6=6)
      COMMON /PLOT01/ A(3,3), TRANS(3), SCALE, ROT(3,3), CENTER(3)
      COMMON /PLOT02/ PENUP, XNOW, YNOW, IPASS, XEXT, SCAL3, SCAL4,
     |                XSHIF
      COMMON /SLAB01/ WINDOW(6), XS(6), YS(6), ZS(6), DELTA
C
      CHARACTER*1  PTYPE, QTYPE(9), ANSWER, QSPACE
      CHARACTER*63 FILE, title
      CHARACTER*80 LINE
      LOGICAL      SKIP, PENUP, usecolor
      INTEGER      JMODE(100)
      integer iu101
      real colr(3)
      REAL*4       XEXT(4)
      REAL*4       SCAL3, SCAL4, XSHIF
      REAL         XYZ(3), XYZTMP(3,2), RWIDTH(100)
      data XEXT/1.0e32,-1.0e32,1.0e32,-1.0e32/
      data SCAL3/1.0/, SCAL4/1.0/, XSHIF/0.0/
      DATA         QTYPE/'M','m','L','l','R','r','S','s','3'/
      DATA         SEP/7.0/, CSIZE /10.0/ , SFACT /1.0/ , PTYPE/'S'/
      DATA         WIDTH /0.25/ , CHROFF /0.0/ , QSPACE /' '/
	data iu101 /79/
C
C   Initialize the plotter and set window.  In this version, the plot
C   area always remains from -10 to +10 in X and Y.  The coordinates
C   rather than the window is shifted.
C
      PENUP     = .FALSE.
      WRITE(LUN6,1000)
C
C   Read name of the PostScript output file
C
      WRITE (LUN6,1300)
      READ  (LUN5,1200) FILE
      write (iu101, '(63a1)' ) (FILE(j:j), j=1,63)
      CALL PSOPEN (LUN2,FILE,1,.TRUE.,IERR)
      IF (IERR.NE.0) GOTO 910
	write(lun6,*) ' Title:'
	read(lun5, '(a60)' ) title(1:60)
	write(iu101, '(a60)' ) title(1:60)
C
C   Plot type ( Mono / Left / Right / Stereo / LRL)
C
        usecolor = .false.
      WRITE (LUN6,1450) 'No'
      READ  (LUN5,1200) ANSWER
      write (iu101, '(a1, 5x,  6H!color)' )  ANSWER
      IF (ANSWER .NE. QSPACE) then
         if (answer .eq. 'y' .or. answer .eq. 'Y' ) usecolor = .true.
         end if
      WRITE (LUN6,1400) PTYPE
      READ  (LUN5,1200) ANSWER
      write (iu101, '(a1, 5x,  7H!stereo)' )  ANSWER
      IF (ANSWER .NE. QSPACE) PTYPE = ANSWER
      ITYPE = 4
      DO 110 I = 1,9
        IF (PTYPE.EQ.QTYPE(I)) ITYPE = (I+1)/2
  110 CONTINUE
	if ( itype .ge. 4 ) then
	wndsiz = 4.5
	else
	wndsiz = 20.
	end if
c window size
      WRITE (LUN6,1501 ) wndsiz
      READ  (LUN5,1600 ) VALUE
      write (iu101, '(f10.2, 5x, 7H!window )' ) VALUE
      IF ( value .gt. 0.0) wndsiz = value
C
C   Character size
C
      WRITE (LUN6,1500) CSIZE
      READ  (LUN5,1600) VALUE
      write (iu101, '(f10.2, 5x, 8H!ch-size )' ) VALUE
      IF (VALUE.NE.0.0) CSIZE = VALUE
      IF (CSIZE.LE.0.0) CSIZE = 10.0
C
C   Horizontal character offset
C
      CHROFF = 0.0
      WRITE (LUN6,1700) CHROFF
      READ  (LUN5,1600) VALUE
      write (iu101, '(f10.2, 5x, 10H!ch-offset )' ) VALUE
      IF (VALUE.NE.0.0) CHROFF = VALUE
C
C   Scale factor. L-R-L does it's own scaling.
C
      IF (ITYPE.NE.5) THEN
       WRITE (LUN6,1800) SFACT
       READ  (LUN5,1600) VALUE
      write (iu101, '(f10.2, 5X, 6H!scale )' ) VALUE
       IF (VALUE.NE.0.0) SFACT = VALUE
       IF (SFACT.LE.0.0) SFACT = 1.0
      ENDIF
C
C   Stereo Separation
C
      NUMPAS    = 1
      LOWPAS    = 1
      IF (ITYPE.EQ.4) THEN
       NUMPAS    = 2
	sep = 5.0
       WRITE (LUN6,1900) SEP
       READ  (LUN5,1600) VALUE
      write (iu101, '(f10.2, 5x, 11H!stereo-sep )' ) VALUE
       IF (VALUE.NE.0.0) SEP = VALUE
       IF (SEP.LE.0.0)   SEP = 5.0
      ENDIF
C
C   L-R-L mode: 4 passes thru the file, 1st for scaling, then L-R-L
C
      IF (ITYPE.EQ.5) THEN
        NUMPAS = 3
        LOWPAS = 0
        SEP    = 6.5 / 2.0
      ENDIF
C
C   Initialize the window
C
      DELTA     =   0.0
      WINDOW(1) = -wndsiz
      WINDOW(2) =  wndsiz
      WINDOW(3) = -wndsiz
      WINDOW(4) =  wndsiz
      WINDOW(5) = -wndsiz
      WINDOW(6) =  wndsiz
C
      DO 120  I = 1,6
       XS(I)    = 0
       YS(I)    = 0
       ZS(I)    = 0
  120 CONTINUE
C
C   Write the PostScript preamble with macro def's
C
      WRITE (LUN2,2000) CSIZE
	WRITE (LUN2,2200) title(1:60)
C
C   Read next plot file name
C
  100 WRITE (LUN6,1100)
      READ  (LUN5,1200) FILE
      write (iu101, '(63a1)' ) (FILE(j:j), j=1,63)
      IF (FILE(1:1) .EQ. QSPACE) GOTO 920
      CALL PSOPEN (LUN1,FILE,1,.FALSE.,IERR)
      IF (IERR.NE.0) GOTO 900
C
C   Make pass through the data (twice for stereo, four times for LRL stereo)
C
      DO 200 IPASS = LOWPAS,NUMPAS
       REWIND LUN1
C
C   Calc additional L-R-L scale factor after pass 0. Magic number 24.0
C   is the number of typographical points in a centimeter. The even more
C   magical number 1.179 is to convert the output to centimeters. This
C   program otherwise works in some arbitrary unit of measurement, but
C   certainly not in metric/points/inches or such.
C
       IF (ITYPE.EQ.5 .AND. IPASS.EQ.1) THEN
         SCAL3 = 5.3 * 24.0 / ( XEXT(2)-XEXT(1) )
         SCAL4 = 1.179
         XSHIF = -140.0
       ENDIF
C
C   Set clipping window
C
      JCOUNT    = 0
       IF (ITYPE.GE.4) THEN
        WINDOW(1) = -wndsiz
        WINDOW(2) =  wndsiz
        WINDOW(3) = -wndsiz
        WINDOW(4) =  wndsiz
        IF (IPASS.EQ.1) THEN
         DELTA = -1.0 * SEP / SCAL3
        ELSE IF (IPASS.EQ.3) THEN
         DELTA =  3.0 * SEP / SCAL3
        ELSE
         DELTA =  SEP / SCAL3
        ENDIF
       ENDIF
C
C   Set up the stereo rotation matrix. Note that we always use a 6 degree
C   stereo angle since PSFRODO does not pass the (variable) stereo parameters
C   into the plot file.
C
       IF ((ITYPE.GE.4 .AND. (IPASS.EQ.1.OR.IPASS.EQ.3))
     |       .OR.ITYPE.EQ.2) THEN
        COS3 = COS(-3.14159 * 3.00 /180.0)
        SIN3 = SIN(-3.14159 * 3.00 /180.0)
       ELSE IF ((ITYPE.GE.4.AND.IPASS.EQ.2).OR.ITYPE.EQ.3) THEN
        COS3 = COS(3.14159 * 3.00 /180.0)
        SIN3 = SIN(3.14159 * 3.00 /180.0)
       ELSE
        COS3 = 1.0
        SIN3 = 0.0
       ENDIF
C  
       ROT(1,1) = COS3
       ROT(1,2) = 0
       ROT(1,3) = SIN3
       ROT(2,1) = 0
       ROT(2,2) = 1.0
       ROT(2,3) = 0
       ROT(3,1) = -SIN3
       ROT(3,2) = 0
       ROT(3,3) = COS3
C
C   Read and interpret the next command
C
  130  READ  (LUN1,1200,END=200) LINE
C
C   Title
C
  140  continue
	IF (LINE(1:4).EQ.'TITL') THEN
        IF (IPASS.eq.11) WRITE (LUN2,2200) LINE(7:66)
C
C   Cell - ignore
C
       ELSE IF (LINE(1:4).EQ.'CELL') THEN
C
C   Center
C
       ELSE IF (LINE(1:4).EQ.'CENT') THEN
        READ  (LINE,2100) CENTER
C
C   View
C
       ELSE IF (LINE(1:4).EQ.'VIEW') THEN
        READ  (LINE,2100) A
C
C   Translation
C
       ELSE IF (LINE(1:4).EQ.'TRAN') THEN
        READ  (LINE,2100) TRANS
C
C   Scale Factor
C
       ELSE IF (LINE(1:4).EQ.'SCAL') THEN
        READ  (LINE,2100) SCALE
C
C   Scale SCALE for stereo drawings
C
        IF (ITYPE.EQ.4) SCALE = 0.8 * SCALE
        SCALE = SCALE*SFACT
C
C   Slab value
C
       ELSE IF (LINE(1:4).EQ.'SLAB') THEN
        READ  (LINE,2100) ASLAB
        WINDOW(5) = -ASLAB * SFACT
        WINDOW(6) =  ASLAB * SFACT
C
C   Atom list - ignore
C
       ELSE IF (LINE(1:4).EQ.'ATOM') THEN
C
C   Identification. I am not sure if PSFRODO ever emits a ID, LABE or 
C   CROS line that is not preceeded by a DISP line. It might well
C   be that the following 5 lines are never executed. ak.
C
       ELSE IF (LINE(1:2).EQ.'ID'.OR.LINE(1:4).EQ.'LABE') THEN
        IF (IPASS.NE.0) THEN
c	ynow = 99999.
c	xnow = 99999.
         READ (LINE,2100) XYZ
         CALL LSLAB (XYZ, 0)
	ilast = 40
	do 186 ik = 80,31,-1
	if( line(ik:ik) .eq. ' ' ) goto 186
	ilast = ik
	goto 187
186	continue
187	continue
c        if ( xnow .lt. 99990 .and. ynow .lt. 99990 ) 
	WRITE (LUN2,2300) LINE(31:ilast),XNOW+CHROFF,YNOW+CHROFF
        ENDIF
C
C   3-D cross. Same comments as above. ak.
C
       ELSE IF (LINE(1:4).EQ.'CROS') THEN
        READ (LINE,2100) XYZ
        DO 160 J = 1,3
         DO 150 I = 1,3
          IF (J.EQ.I) THEN
           XYZTMP(I,1) = XYZ(I)-0.2
           XYZTMP(I,2) = XYZ(I)+0.2
          ELSE
           XYZTMP(I,1) = XYZ(I)
           XYZTMP(I,2) = XYZ(I)
          ENDIF
  150    CONTINUE
         CALL LSLAB (XYZTMP(1,1),0)
         CALL LSLAB (XYZTMP(1,2),1)
  160   CONTINUE
C
C   Display structure
C
       ELSE IF (LINE(1:4).EQ.'DISP') THEN
        JCOUNT = JCOUNT+1
        SKIP   = .FALSE.
        IF (IPASS.EQ.LOWPAS) THEN
         WRITE (LUN6,2400) LINE(8:11)
         READ  (LUN5,2500) MODE
	write (iu101, '( i5, 5x, 2H!  , a4)' ) mode, line(8:11)
         IF (MODE.EQ.1) MODE = 3
         IF (MODE.LT.-1 .OR. MODE.GT.20) MODE = 0
         IF (MODE.NE.-1) THEN
          WRITE (LUN6,2600) WIDTH
          READ  (LUN5,1600) REAL4
      write (iu101, '(f10.2)' ) real4
          IF (REAL4.GT.0.0) WIDTH = REAL4
         END IF
C
C   Check for integer value
C
         JMODE(JCOUNT) = MODE
         RWIDTH(JCOUNT) = WIDTH
        ELSE
         MODE      = JMODE(JCOUNT)
         WIDTH     = RWIDTH(JCOUNT)
        ENDIF 
C
C   Select drawing mode, do not allow more than 20 dashes/A
C
        SKIP = MODE .EQ. -1
        IF (.NOT. SKIP) WRITE (LUN2,3000) WIDTH
        GOTO 170
C
C   Unrecognized command
C
       ELSE
        WRITE (LUN6,3100)LINE
       ENDIF
       GOTO 130
C
C   Read drawing command
C
  170 READ  (LUN1,1200,END=200)LINE
C
C   New display structure
C
      IF (LINE(1:4).EQ.'DISP') GOTO 140
C
C   In skip mode, just ignore the line
C
      IF (SKIP) GOTO 170
C
C   Move command
C
c      write(*,*) ' line >', LINE(1:4), '< ', line
      IF (LINE(1:4).EQ.'MOVE') THEN
       READ  (LINE,2100) XYZ
       CALL DASH(XYZ,0,MODE)
C
C   Draw command
C
      ELSE IF (LINE(1:4).EQ.'DRAW') THEN
       READ  (LINE,2100) XYZ
       CALL DASH(XYZ,1,MODE)
C
C   Dots command
C
      ELSE IF (LINE(1:4).EQ.'DOTS') THEN
       READ  (LINE,2100) XYZ
       CALL LSLAB (XYZ,0)
       CALL LSLAB (XYZ,1)
C
C   LABEL & ID commands
C
      ELSE IF (LINE(1:2).EQ.'ID'.OR.LINE(1:4).EQ.'LABE') THEN
       IF (IPASS .NE. 0) THEN
c	ynow = 99999.
c	xnow = 99999.
        READ (LINE,2100) XYZ
        CALL LSLAB (XYZ, 0)
	ilast = 40
	do 188 ik = 80,31,-1
	if( line(ik:ik) .eq. ' ' ) goto 188
	ilast = ik
	goto 189
188	continue
189	continue
c        if ( xnow .lt. 99990 .and. ynow .lt. 99990 ) 
	WRITE (LUN2,2300) LINE(31:ilast),XNOW+CHROFF,YNOW+CHROFF
       ENDIF
C
C   Cross command
C
      ELSE IF (LINE(1:4).EQ.'CROS') THEN
       READ  (LINE,2100) XYZ
       DO 190 J = 1,3
        DO 180 I = 1,3
         IF (J.EQ.I) THEN
          XYZTMP(I,1) = XYZ(I)-0.2
          XYZTMP(I,2) = XYZ(I)+0.2
         ELSE
          XYZTMP(I,1) = XYZ(I)
          XYZTMP(I,2) = XYZ(I)
         ENDIF
  180   CONTINUE
        CALL LSLAB (XYZTMP(1,1),0)
        CALL LSLAB (XYZTMP(1,2),1)
  190  CONTINUE
C
C   Color command - ignore
C
      ELSE IF (LINE(1:4).EQ.'COLO') THEN
C
C   Uninterpreted command
         if ( usecolor ) then
         read(line(6:32), '(3f7.4)', err=140) colr
         write(lun2, 3333 ) colr
 3333    format( ' gsave ', 3f7.4, '  setrgbcolor' )
         end if
C
      ELSE
       GOTO 140
      ENDIF
       GOTO 170
C
C   The end of file has been reached
C
  200 CONTINUE
      CLOSE(UNIT=LUN1)
      GOTO 100
C
C   Errors
C
  900 WRITE (LUN6,3300)
	goto 100
c      STOP 
C
  910 WRITE (LUN6,3400)
      STOP 
C
  920 WRITE (LUN6,3500)
      WRITE (LUN2,3200)
      CLOSE(UNIT=2)
C
 1000 FORMAT('0Program LWPLOT (PS300 FRODO version 6.6)',/)
 1100 FORMAT('$LWP> Enter plot file name (or <CR> to end) : ')
 1200 FORMAT(A)
 1300 FORMAT('$LWP> Enter the output file or device name : ')
 1400 FORMAT('$LWP> Enter plot type (Mono,Left,Right,Stereo,',
     |       '3-Pic-Stereo) [',A,']: ')
 1450 FORMAT('$LWP> Enter color use (No, Yes) [',A,']: ')
 1500 FORMAT('$LWP> Enter Character point size [',F6.3,']: ')
 1501 FORMAT('$LWP> Enter window size [',F6.3,']: ')
 1600 FORMAT(F10.0)
 1700 FORMAT('$LWP> Enter ID offset [',F5.2,'] : ')
 1800 FORMAT('$LWP> Enter Scale factor [',F6.3,']: ')
 1900 FORMAT('$LWP> Enter stereo separation [',F6.3,']: ')
 2000 FORMAT('%!',/,'% PSFRODO PostScript Plot File'/
     |'% Generated by LWPlot V6.6.3 - enhancements by Andi Karrer'/
     |'/fnr /Helvetica findfont ',F5.2,' scalefont def'/
     |'/fnt /Helvetica-Bold findfont 12.0 scalefont def'/
     |'/shwr {moveto fnr setfont show} def'/
     |'/shwt {moveto fnt setfont show} def'/
     |'/m {moveto} bind def',/,
     |'/l {lineto} bind def',/,
     |'/s {stroke} bind def',/,
     |'statusdict begin/setduplexmode where {pop false setduplexmode} ',
     |' if end',/,
     |'newpath',/,
     |'300 360 translate',/,'-90 rotate',/,
     |'1.415 setmiterlimit',/,'.25 setlinewidth'/)
 2100 FORMAT(6X,9F8.4)
 2200 FORMAT('(',A,') -250 -250 shwt')
 2300 FORMAT ('(',A,')',2F9.2,' shwr')
 2400 FORMAT('$LWP> Display ',A4,
     |       ' (-1:Skip / 0:Line / N>0:N dashes per A) : ')
 2500 FORMAT(I5)
 2600 FORMAT('$LWP> Enter line width in points [',f5.2,'] : ')
 3000 FORMAT('s'/,F5.2,' setlinewidth')
 3100 FORMAT('0LWP> Unable to interpret line:',/1X, A)
 3200 FORMAT('s showpage')
 3300 FORMAT('0LWP> Unable to access the input file')
 3400 FORMAT('0LWP> Unable to access the output file')
 3500 FORMAT('0LWP> End of program LWPLOT')
      END 

      SUBROUTINE DASH (X, IMOVE, MODE)
C
C   This is a new subroutine. Andi Karrer 7-Dec-89.
C
C   If MODE is 0, this subroutine degenerates to LSLAB.
C   If not, the current bond is split into dashes and each dash is passed
C   separately to LSLAB. We also make sure that the endpoints of the line are
C   in pen-down mode, e.g.    *--    ----    --*  . The dashes at the
C   endpoints are only half as long as the ones in the middle.
C
      IMPLICIT NONE
      INTEGER  I, J, IMOVE, MODE, NDASH, PENUP
      REAL*4   X(3), X1(3), DX(3), X2(3), D
C
C   X1 must retain its value between multiple invocations of this routine.   
C
      SAVE     X1
C
      IF (MODE.EQ.0) THEN
        CALL LSLAB(X, IMOVE)
      ELSE
        IF (IMOVE.EQ.1) THEN
C
C   Calc length of bond and find how many dashes we need. Beware of
C   zero-dash bonds.
C
          D = 0.0
          DO 10 I=1,3
            DX(I) = X(I) - X1(I)
            D = D + DX(I)**2
   10     CONTINUE
          D = SQRT(D)
c          NDASH = MAX(1,INT(D*MODE+0.5)*4)
          NDASH = 4*mode
          DO 20 I=1,3
            DX(I) = 2.0 * DX(I) / FLOAT(NDASH)
            X2(I) = X1(I) + DX(I) / 2.0
   20     CONTINUE
C
C   first semi-length line segment
C
          CALL LSLAB(X1, 0)
          CALL LSLAB(X2, 1)
C
C   middle full length line segments
C
	  PENUP = 1
          DO 40 I=2,NDASH/2
            PENUP = 1 - PENUP
            DO 30 J=1,3
              X2(J) = X2(J) + DX(J)
   30       CONTINUE
            CALL LSLAB(X2, PENUP)
   40     CONTINUE
C
C   last semi-length line segment
C
          CALL LSLAB(X,  1)
        ENDIF
C
C   Store point where we were
C
        DO 50 I=1,3
          X1(I) = X(I)
  50    CONTINUE
      ENDIF
C
      END

      SUBROUTINE LSLAB (XYZ, IMOVE)
C
C   PS300 FRODO version 6.3  (JSS  01-JAN-1987)
C
C   Subroutine LSLAB does the clipping. The three-dimensional clipping 
C   routines from the book, COMPUTER GRAPHICS: A Programming Approach, 
C   Steven Harrington, McGraw-Hill (1983).
C
C   Original source from J.W. Pflugrath (MPI Munich) (17-DEC-1985)
C
      COMMON /SLAB01/ WINDOW(6), XS(6), YS(6), ZS(6), DELTA
      COMMON /PLOT01/ A(3,3), TRANS(3), SCALE, ROT(3,3), CENTER(3)
      REAL   XYZ(3)
C
      XC   = (XYZ(1) - CENTER(1)) * SCALE
      YC   = (XYZ(2) - CENTER(2)) * SCALE
      ZC   = (XYZ(3) - CENTER(3)) * SCALE
C
      XR   = A(1,1) * XC + A(2,1) * YC + A(3,1) * ZC + TRANS(1)
      YR   = A(1,2) * XC + A(2,2) * YC + A(3,2) * ZC + TRANS(2)
      ZR   = A(1,3) * XC + A(2,3) * YC + A(3,3) * ZC + TRANS(3)
C
      X    = ROT(1,1) * XR + ROT(2,1) * YR + ROT(3,1) * ZR
      Y    = ROT(1,2) * XR + ROT(2,2) * YR + ROT(3,2) * ZR
      Z    = ROT(1,3) * XR + ROT(2,3) * YR + ROT(3,3) * ZR
C
C
      IF ( XS(1) .LT. WINDOW(1))  THEN
       ZSLAB     = SLABZ(X, Z, XS(1), ZS(1), WINDOW(1))
       XSLAB     = WINDOW(1)
       YSLAB     = SLABXY(X, Y, Z, XS(1), YS(1), ZS(1),XSLAB, ZSLAB)
       CALL LSLABR (XSLAB, YSLAB, ZSLAB, 0)
      ENDIF
C
      XS(1)     = X
      YS(1)     = Y
      ZS(1)     = Z
      IF (X .GE. WINDOW(1)) CALL LSLABR (X, Y, Z, IMOVE)
      RETURN
      END

      FUNCTION SLABZ (A1, Z1, A2, Z2, B)
C
C   PS300 FRODO version 6.3  (JSS  01-JAN-1987)
C
C   Subroutine SLABZ calculates the Z-clipping
C
C   Original source from J.W. Pflugrath (MPI Munich) (17-DEC-1985)
C
      IF ( ABS(A2 - A1) .GT. 0.0005) THEN
       SLABZ = ((A2-A1)*Z1+(B-A1)*(Z2-Z1))/(A2-A1)
      ELSE
       SLABZ = Z1
      END IF
      RETURN
      END

      FUNCTION SLABXY (A1, B1, Z1, A2, B2, Z2, ASLAB, ZSLAB)
C
C   PS300 FRODO version 6.3  (JSS  01-JAN-1987)
C
C   Subroutine SLABXY calculates the XY clipping
C
C   Original source from J.W. Pflugrath (MPI Munich) (17-DEC-1985)
C
      IF ( ABS(Z2 - Z1) .GT. 0.0005) THEN
         SLABXY     = (B2 - B1) / (Z2 - Z1) * (ZSLAB - Z1) + B1
      ELSE IF ( ABS(A2 - A1) .GT. 0.0005) THEN
         SLABXY     = (B2 - B1) / (A2 - A1) * (ASLAB - A1) + B1
      ELSE
         SLABXY     = B1
      ENDIF
      RETURN
      END

      SUBROUTINE LSLABR (X, Y, Z, IMOVE)
C
C   PS300 FRODO version 6.3  (JSS  01-JAN-1987)
C
C   Subroutine LSLABR calculates the right clipping plane
C
C   Original source from J.W. Pflugrath (MPI Munich) (17-DEC-1985)
C
      COMMON /SLAB01/ WINDOW(6), XS(6), YS(6), ZS(6), DELTA
C
      ZSLAB     = SLABZ (X, Z, XS(2), ZS(2), WINDOW(2))
      XSLAB     = WINDOW(2)
      YSLAB     = SLABXY (X, Y, Z, XS(2), YS(2), ZS(2),XSLAB, ZSLAB)
      IF ( (X .LE. WINDOW(2)) .AND. (XS(2) .GT. WINDOW(2)) ) 
     1 CALL LSLABB (XSLAB, YSLAB, ZSLAB, 0)
      IF ( (X .GE. WINDOW(2)) .AND. (XS(2) .LT. WINDOW(2)) ) 
     1 CALL LSLABB (XSLAB, YSLAB, ZSLAB, IMOVE)
C
      XS(2)     = X
      YS(2)     = Y
      ZS(2)     = Z
      IF (X .LE. WINDOW(2)) CALL LSLABB (X, Y, Z, IMOVE)
      RETURN
      END

      SUBROUTINE LSLABB (X, Y, Z, IMOVE)
C
C   PS300 FRODO version 6.3  (JSS  01-JAN-1987)
C
C   Subroutine LSLABB calculates the bottom clipping plane
C
C   Original source from J.W. Pflugrath (MPI Munich) (17-DEC-1985)
C
      COMMON /SLAB01/ WINDOW(6), XS(6), YS(6), ZS(6), DELTA
C
      ZSLAB     = SLABZ(Y, Z, YS(3), ZS(3), WINDOW(3))
      YSLAB     = WINDOW(3)
      XSLAB     = SLABXY(Y, X, Z, YS(3), XS(3), ZS(3),YSLAB, ZSLAB)
      IF ( (Y .GE. WINDOW(3)) .AND.(YS(3) .LT. WINDOW(3)) ) 
     1 CALL LSLABT (XSLAB, YSLAB, ZSLAB, 0)
      IF ( (Y .LE. WINDOW(3)) .AND.(YS(3) .GT. WINDOW(3)) ) 
     1 CALL LSLABT (XSLAB, YSLAB, ZSLAB, IMOVE)
C
      XS(3)     = X
      YS(3)     = Y
      ZS(3)     = Z
      IF (Y .GE. WINDOW(3)) CALL LSLABT (X, Y, Z, IMOVE)
      RETURN
      END

      SUBROUTINE LSLABT (X, Y, Z, IMOVE)
C
C   PS300 FRODO version 6.3  (JSS  01-JAN-1987)
C
C   Subroutine LSLABT calculates the top clipping plane
C
C   Original source from J.W. Pflugrath (MPI Munich) (17-DEC-1985)
C
      COMMON /SLAB01/ WINDOW(6), XS(6), YS(6), ZS(6), DELTA
C
      ZSLAB = SLABZ(Y, Z, YS(4), ZS(4), WINDOW(4))
      YSLAB = WINDOW(4)
      XSLAB = SLABXY(Y, X, Z, YS(4), XS(4), ZS(4),YSLAB, ZSLAB)
      IF ( (Y .LE. WINDOW(4)) .AND.(YS(4) .GT. WINDOW(4)) ) 
     1 CALL LSLABK (XSLAB, YSLAB, ZSLAB, 0)
      IF ( (Y .GE. WINDOW(4)) .AND.(YS(4) .LT. WINDOW(4)) ) 
     1 CALL LSLABK (XSLAB, YSLAB, ZSLAB, IMOVE)
C
      XS(4) = X
      YS(4) = Y
      ZS(4) = Z
      IF (Y .LE. WINDOW(4)) CALL LSLABK (X, Y, Z, IMOVE)
      RETURN
      END

      SUBROUTINE LSLABK (X, Y, Z, IMOVE)
C
C   PS300 FRODO version 6.3  (JSS  01-JAN-1987)
C
C   Subroutine LSLABK calculates the back clipping plane
C
C   Original source from J.W. Pflugrath (MPI Munich) (17-DEC-1985)
C
      COMMON /SLAB01/ WINDOW(6), XS(6), YS(6), ZS(6), DELTA
C
      IF (Z.NE.ZS(5))CHANGE = (-WINDOW(6) - Z) / (Z - ZS(5))
      XSLAB = (X - XS(5)) * CHANGE + X
      YSLAB = (Y - YS(5)) * CHANGE + Y
      IF ( (Z .GE. -WINDOW(6)) .AND. (ZS(5) .LT. -WINDOW(6)) ) 
     1 CALL LSLABF (XSLAB, YSLAB, -WINDOW(6), 0)
      IF ( (Z .LE. -WINDOW(6)) .AND. (ZS(5) .GT. -WINDOW(6)) ) 
     1 CALL LSLABF (XSLAB, YSLAB, -WINDOW(6), IMOVE)
C
      XS(5) = X
      YS(5) = Y
      ZS(5) = Z
      IF (Z .GE. -WINDOW(6)) CALL LSLABF (X, Y, Z, IMOVE)
      RETURN
      END

      SUBROUTINE LSLABF (X, Y, Z, IMOVE)
C
C   PS300 FRODO version 6.3  (JSS  01-JAN-1987)
C
C   Subroutine LSLABF calculates the front clipping plane
C
C   Original source from J.W. Pflugrath (MPI Munich) (17-DEC-1985)
C
      COMMON /SLAB01/ WINDOW(6), XS(6), YS(6), ZS(6), DELTA
C
      IF (Z.NE.ZS(6))CHANGE = (-WINDOW(5) - Z) / (Z - ZS(6))
      XSLAB = (X - XS(6)) * CHANGE + X
      YSLAB = (Y - YS(6)) * CHANGE + Y
      IF ( (Z .LE. -WINDOW(5)) .AND. (ZS(6) .GT. -WINDOW(5)) ) 
     1 CALL LPLOT (XSLAB+DELTA, YSLAB, 0)
      IF ( (Z .GE. -WINDOW(5)) .AND. (ZS(6) .LT. -WINDOW(5)) )
     1 CALL LPLOT (XSLAB+DELTA, YSLAB, IMOVE)
C
      XS(6) = X
      YS(6) = Y
      ZS(6) = Z
      IF (Z .LE. -WINDOW(5)) CALL LPLOT (X+DELTA, Y, IMOVE)
      RETURN
      END

      SUBROUTINE LPLOT (X, Y, IMOVE)
C
C   PS300 FRODO version 6.3  (JSS  01-JAN-1987)
C
C   Subroutine LPLOT creates the POSTSCRIPT commands from MOVES or DRAWS
C
      PARAMETER ( LUN2 = 2 )
      REAL*4  XEXT(4), SCAL3, SCAL4
      COMMON /PLOT02/ PENUP, XNOW, YNOW, IPASS, XEXT, SCAL3, SCAL4,
     |                XSHIF
      LOGICAL PENUP
      SAVE ICOUNT
C
C   MOVE Command  (Save the point)
C
      IF (IMOVE.EQ.0) THEN
       PENUP    = .TRUE.
       XNOW     = (24.0 * X - 35) * SCAL3 * SCAL4 + XSHIF
       YNOW     = (24.0 * Y + 15) * SCAL3 * SCAL4
C
C   DRAW Command
C
      ELSE
       IF (PENUP) THEN
        ICOUNT    = ICOUNT+1
        IF (ICOUNT.GE.500) THEN
         ICOUNT = 0
         IF (IPASS.NE.0) WRITE (LUN2,1000) 
        END IF
        IF (IPASS.NE.0) WRITE (LUN2,1100) XNOW, YNOW
       END IF
       ICOUNT = ICOUNT + 1
       PENUP    = .FALSE.
       XNOW     = (24.0 * X - 35) * SCAL3 * SCAL4 + XSHIF
       YNOW     = (24.0 * Y + 15) * SCAL3 * SCAL4
       IF (IPASS.EQ.0) THEN
         XEXT(1) = MIN(XEXT(1),XNOW)
         XEXT(2) = MAX(XEXT(2),XNOW)
         XEXT(3) = MIN(XEXT(3),YNOW)
         XEXT(4) = MAX(XEXT(4),YNOW)
       ELSE
         WRITE (LUN2,1200) XNOW, YNOW
       ENDIF
      END IF
      RETURN 
C
 1000 FORMAT ('s')
 1100 FORMAT (F7.2,1X,F7.2,' m')
 1200 FORMAT (F7.2,1X,F7.2,' l')
      END 
