C  **********************************************************************
C  *                                                                    *
C  *   The following subroutine contains non-standard FORTRAN 77 code   *
C  *                                                                    *
C  **********************************************************************
C  *        This program code, a part of FRODO for PS 300, is           * 
C  *                      licensed and copyrighted.                     *
C  *               Redistribution is expressly prohibited.              *
C  **********************************************************************
C
      SUBROUTINE PSOPEN (LUN, FNAME, IFILE, TYPE, IERR)
      implicit none
      integer lun, ifile, ierr
C
C   PS300 FRODO version 6.6  (JSS  01-JUN-1988)
C
C   UTILITY subroutine PSOPEN is used to open a data file given the logical 
C   unit number, file type, file name, and whether the file is to be read 
C   or written.
C
C   Changes for version 6.6:
C
C   1. Change name from FOPEN to prevent Wollengong conflict
C
C   Original source from PS300 FRODO version 6.2  (JSS  01-JAN-1986)
C
      LOGICAL TYPE
      LOGICAL ISOPEN
      CHARACTER*(*) FNAME
C
      IERR      = 0
      INQUIRE (UNIT = LUN, OPENED=ISOPEN)
      IF (ISOPEN) CLOSE ( UNIT = LUN )
C
C   Standard formated file
C
      IF (IFILE.EQ.1) THEN
       IF (TYPE) THEN
#ifndef LINUX
c        OPEN (UNIT=LUN,FILE=FNAME,STATUS='unknown',ERR=900,
c     1  CARRIAGECONTROL='LIST',IOSTAT=IOS)
        OPEN (UNIT=LUN, FILE=FNAME, STATUS='unknown',ERR=900,
     1  CARRIAGECONTROL='LIST')
#endif
#ifdef LINUX
        OPEN (UNIT=LUN,FILE=FNAME,STATUS='unknown',ERR=900)
#endif
       ELSE
#ifndef LINUX
c        OPEN (UNIT=LUN,FILE=FNAME,STATUS='OLD',READONLY,
c     1  ERR=900,IOSTAT=IOS)
          OPEN (UNIT=LUN,FILE=FNAME,STATUS='OLD',READONLY,
     1         ERR=900)
#endif
#ifdef LINUX
        OPEN (UNIT=LUN, FILE=FNAME, STATUS='OLD', ERR=900 )
       END IF
#endif
#ifndef LINUX
C
C   Atomic coordinate file
C
      ELSE IF (IFILE.EQ.2) THEN
       IF (TYPE) THEN
      OPEN  (UNIT=LUN,FILE=FNAME,STATUS='NEW',FORM='UNFORMATTED',
     1 ACCESS='DIRECT',RECL=8,ERR=900)
      ELSE 
      OPEN (UNIT=LUN,FILE=FNAME,STATUS='OLD',FORM='UNFORMATTED',
     1 ACCESS='DIRECT',RECL=8,ERR=900)
      END IF
C
C   Vector style density file
C
      ELSE IF (IFILE.EQ.3) THEN
       IF (TYPE) THEN
        OPEN  (UNIT=LUN,FILE=FNAME,STATUS='NEW',ACCESS='DIRECT',
     1  FORM='UNFORMATTED',RECL=32,ERR=900)
       ELSE
        OPEN  (UNIT=LUN,FILE=FNAME,STATUS='OLD',ACCESS='DIRECT',
     1  READONLY,FORM='UNFORMATTED',RECL=32,ERR=900)
       END IF
C
C   MAP style density
C
      ELSE IF (IFILE.EQ.4) THEN
       IF (TYPE) THEN
      OPEN  (UNIT=LUN,FILE=FNAME,STATUS='NEW',ACCESS='DIRECT',
     1 RECL=128,ERR=900)
       ELSE
      OPEN  (UNIT=LUN,FILE=FNAME,STATUS='OLD',ACCESS='DIRECT',
     1 READONLY,RECL=128,ERR=900)
       END IF
C
C   Input electron density file
C
      ELSE IF (IFILE.EQ.5) THEN
      IF (TYPE) THEN
        OPEN (UNIT=LUN,FILE=FNAME,STATUS='NEW',FORM='UNFORMATTED',
     1        ERR=900)
      ELSE
        OPEN (UNIT=LUN,FILE=FNAME,STATUS='OLD',FORM='UNFORMATTED',
     1        READONLY,ERR=900)
      END IF
C
C   DSN1 MOLCUL file
C
      ELSE IF (IFILE.EQ.6) THEN
      IF (TYPE) THEN
      OPEN  (UNIT = LUN, FILE= FNAME, STATUS = 'UNKNOWN',
     1      ORGANIZATION = 'SEQUENTIAL', ACCESS = 'SEQUENTIAL',
     2      FORM = 'UNFORMATTED', RECORDTYPE = 'SEGMENTED',
     3      RECL = 62, ERR = 900)
      ELSE
      OPEN  (UNIT = LUN, FILE= FNAME, STATUS = 'SCRATCH',
     1      ORGANIZATION = 'SEQUENTIAL', ACCESS = 'SEQUENTIAL',
     2      FORM = 'UNFORMATTED', RECORDTYPE = 'SEGMENTED',
     3      RECL = 62, ERR = 900)
      END IF
C
C   Overwriting the control file
C
      ELSE IF (IFILE.EQ.7) THEN
       OPEN (UNIT=LUN,FILE=FNAME,STATUS='OLD',ERR=900)
C
C   Creating or overwritting a VECTOR file in VECXYZ
C
C   Vector style density file
C
      ELSE IF (IFILE.EQ.8) THEN
       OPEN  (UNIT=LUN,FILE=FNAME,STATUS='UNKNOWN',ACCESS='DIRECT',
     1  FORM='UNFORMATTED',RECL=32,ERR=900)
#endif
      END IF
      RETURN
C
#ifdef LINUX
 900  IF (IFILE.EQ.2 ) THEN
       IERR      = -1
      ELSE
       IERR      = -2
      END IF
#else
 900  IF (IFILE.EQ.2 .AND. IOS.EQ.29) THEN
       IERR      = -1
      ELSE
       IERR      = IOS
      END IF
#endif
      RETURN
      END
