#!/usr/bin/perl -w
use strict;

print " @ARGV \n" ;

my %commands = () ;
my $chr_scal =  3 ;
my @chr_color =  (0.0, 0.0, 0.0) ;
my $chr_color_flag = 'no' ;
my $lib_dir = $ENV{MAIN_R3D_FONT} ;
my $out_file = "labels_out.r3d" ;
my $head_file = "head.r3d" ;
(%commands) = get_commands ( @ARGV ) ;

my $i = 0 ; my $keyword ; 
foreach $keyword ( sort keys (%commands) ) 
{
    $i++ ; 
    print "$i.) >$keyword<:  @{$commands{$keyword}}\n";
    if ( $keyword eq 'h' || substr($keyword, 0,4) eq "help"  ) { goto HELP ; }
    if ( $keyword eq 'l' || substr($keyword, 0,6) eq "labels"  ) { goto LABEL ; }
    if ( $keyword eq 's' || substr($keyword, 0,5) eq "scale"  )  { goto CHR_SCALE ; }
    if ( $keyword eq 'c' || substr($keyword, 0,5) eq "color"  )  { goto CHR_COLOR ; }
    if ( $keyword eq 'a' || substr($keyword, 0,6) eq "header"  ) { goto HEAD_FILE ; }
    if ( $keyword eq 'o' || substr($keyword, 0,6) eq "output"  ) { goto OUT_FILE ; }
    next ;
  HELP: 
    print" -l/--labels  r3d labels directory >$lib_dir< \n" ;
    print" -s/--scale   character scale >$chr_scal< \n" ;
    print" -a/--header  r3d header contaning view matrix and labels >$head_file< \n" ;
    print" -o/--output  output label r3d file >$out_file< \n" ;
    next ;
  LABEL: 
    $lib_dir = join ( '', @{$commands{$keyword}} ) ; 
    next ;
  CHR_SCALE: 
    $chr_scal = join ( '', @{$commands{$keyword}} ) ; 
    next ;
  CHR_COLOR: 
    $chr_color[2] = pop( @{$commands{$keyword}} ) ; 
    $chr_color[1] = pop( @{$commands{$keyword}} ) ; 
    $chr_color[0] = pop( @{$commands{$keyword}} ) ; 
    $chr_color_flag = 'yes' ;
    next ;
  HEAD_FILE: 
    $head_file = join ( '', @{$commands{$keyword}} ) ; 
    next ;
  OUT_FILE: 
    $out_file = join ( '', @{$commands{$keyword}} ) ; 
    next ;
}

my $line ;

my @labels = () ;
my @coords = () ;

my @matr = () ; my @mat33 = () ;
open ( MATR, $head_file ) || die "NO R3D HEADER FILE with MATRIX \n"; 
for ( $i = 0; $i < 12 ; $i++ ) { $line = <MATR> ; chomp( $line ) ; }
# print " $i my: $line \n" ; }
for ( $i = 0; $i < 3 ; $i++ ) 
{ 
    $line = <MATR> ; chomp( $line ) ;
    print " matr line: $line \n" ;
    @matr = split(' ', $line ) ;
    push(@mat33, $matr[0], $matr[1], $matr[2] ) ;
}

#print "matrix: @mat33 \n" ;
#foreach $i ( @mat33 ) { print "each matrix: $i \n" ; }
#exit ;

for ( $i = 16; $i < 21 ; $i++ ) { $line = <MATR> ; print" $line: $i \n" ; }

my $nlab = 0 ;
$i = 0 ;
while( $line = <MATR> )
{
    chomp( $line ) ;
    $i = $line ;
    print" $line: $i \n" ;
    if ( $i == 16 ) { $line = <MATR> ; print" $line: in 16 \n" ; next ; }
    if ( $i == 11 ) 
    {
	if ( $line = <MATR> ) 
	{ chomp( $line ) ; push ( @coords, $line ); }
	if ( $line = <MATR> ) 
	{ chomp( $line ) ; push ( @labels, $line ); }
	$nlab++;
    }
}

close ( MATR ) ;


#my @matr = () ;
#open ( MATR, $matr_file ) || die "NO MATRIX FILE \n"; 
#while( $line = <MATR> )
#{
#    chomp( $line ) ;
#    push ( @matr, $line ); 
#}
#close ( MATR ) ;
#$line = join (' ', @matr ) ;
#my @mat33 = split(' ', $line ) ;

open ( R3D, "> $out_file" ) || die "can not open OUT file: >$out_file<\n" ; 


my @xyz_s = () ;
my @xyz_e = () ;
my @xyz_lab = () ;

#$nlab = 1 ;

for ($i = 0; $i < $nlab ; $i++ )
{
    print $i, " coords: >", $coords[$i], "< \n" ;
    my @data = split( ' ', $coords[$i] ) ;
    my @xyz_lab = () ; 
    my $r_lab ;
    my $g_lab ;
    my $b_lab ;
    $xyz_lab[0] = $data[0] ; 
    $xyz_lab[1] = $data[1] ;
    $xyz_lab[2] = $data[2] ;
    if ( $chr_color_flag eq 'no' ) 
    { $r_lab = $data[3] ; $g_lab = $data[4] ; $b_lab = $data[5] ; }
    else
    { $r_lab = $chr_color[0] ; $g_lab = $chr_color[1] ; $b_lab = $chr_color[2] ; }

    print $i, " labels: >", $labels[$i], "< \n" ;
    my @letr = split('', $labels[$i] ) ;
    my $a ; my $x_shift = 0 ;
    my $chr_xmax ;
    my $ln3_test = 0 ;
    foreach $a (@letr)
    {
	my $lib_file = join( '', $lib_dir, $a, '.r3d' ) ;
#	printf " TEST >$a<$lib_file> $lib_dir\n" ;
	my $lab_error = 'OK' ;
	open ( LIB, $lib_file ) || goto NOCHAR ; 
#	open ( LIB, $lib_file ) || $lab_error = 'NOTOK' ;
#	    if ( $lab_error eq 'NOTOK' && $a ne ' ' ) { print "MISSING CHAR->$a<\n" ; }
	$chr_xmax = 0 ;
	while ( $line = <LIB> )
	{ 
	    chomp ( $line ) ; # printf " OK CHAR>$a<  $line \n" ; 
	    my @cylinder = split ( ' ', $line ) ;
	    my $nelem = scalar(@cylinder) ;
	    if ( $nelem <= 1 ) 
	    {
		if ( $ln3_test == 0 ) { print R3D "3\n" ; }
		$ln3_test = 1 ;
	    }
	    else
	    {
		$ln3_test = 0 ;
#		print " cylinder @cylinder \n" ;
		$xyz_s[0] = $cylinder[0]*$chr_scal ;
		if ( $xyz_s[0] > $chr_xmax ) { $chr_xmax = $xyz_s[0] ; }
		$xyz_s[0] = $xyz_s[0] + $x_shift ;
		$xyz_s[1] = $cylinder[1]*$chr_scal  ;
		$xyz_s[2] = $cylinder[2]*$chr_scal  ;
#		print " xyz_s @xyz_s \n" ;
		my ( $xs, $ys, $zs ) = rot_tran( \@xyz_s, \@mat33, \@xyz_lab ) ;
		
		$xyz_e[0] = $cylinder[4]*$chr_scal ;
		if ( $xyz_e[0] > $chr_xmax ) { $chr_xmax = $xyz_e[0] ; }
		$xyz_e[0] = $xyz_e[0] + $x_shift ;
		$xyz_e[1] = $cylinder[5]*$chr_scal ;
		$xyz_e[2] = $cylinder[6]*$chr_scal + 0.5 ;
#		print " xyz_e @xyz_e \n" ;
		my ( $xe, $ye, $ze ) = rot_tran( \@xyz_e, \@mat33, \@xyz_lab ) ;

		my $rad = $cylinder[3]*$chr_scal ;

		print R3D "$xs, $ys, $zs $rad $xe, $ye, $ze $rad $r_lab $g_lab $b_lab \n" ;
# die "DIED end here" ;
	    }
	}
	close ( LIB ) ;
	$x_shift = $x_shift + $chr_xmax + $chr_scal*0.02 ; 
	next ;
      NOCHAR:
	$x_shift = $x_shift + $chr_scal*0.12 ; 
	if ( $a ne ' ' ) { print "MISSING CHAR->$a<\n" ; }
    }

}

sub get_commands
{
    my $key = "" ;
    my $word ;
    my %c_line = () ;
    foreach $word ( @_ )
    {
	my @arg_char = split( '', $word ) ;
	if ( $arg_char[0] eq '-' ) 
	{
	    if ( $arg_char[1] eq "-" ) 
	    {
		my $num = scalar(@arg_char) - 1;
		$key = join ( "", @arg_char[2 .. $num] );
		push ( @{$c_line{$key}}, ' ' ) ; 
	}
	else
	{
	    $key = $arg_char[1] ; 
	    push ( @{$c_line{$key}}, ' ' ) ; 
	}
	next ;
	}
	if ( $key ne '' ) 
	{ 
	    $key = lc ( $key ) ; 
#	print "$key: \n" ;
	    my $tmp = join ( '', @{$c_line{$key}} ) ; 
	    if ( $tmp eq ' ' ) { delete $c_line{$key} ; }
	    push ( @{$c_line{$key}}, $word ); 
	}
    }
    return ( %c_line ) ;
}

sub rot_tran 
{
    my ( $x, $tr, $xtran) = @_ ;
    my @t = () ;
#    print " sub rot_tran x @$x \n" ;
#    print " sub rot_tran tr @$tr \n" ;
#    print " sub rot_tran xtran @$xtran \n" ;
    $t[0] = @$x[0]*@$tr[0] + @$x[1]*@$tr[1] + @$x[2]*@$tr[2] + @$xtran[0] ;
    $t[1] = @$x[0]*@$tr[3] + @$x[1]*@$tr[4] + @$x[2]*@$tr[5] + @$xtran[1] ;
    $t[2] = @$x[0]*@$tr[6] + @$x[1]*@$tr[7] + @$x[2]*@$tr[8] + @$xtran[2] ;
    
#    $t[0] = @$xtran[0] ;
#    $t[1] = @$xtran[1] ;
#    $t[2] = @$xtran[2] ;
#    print " sub rot_tran @t \n" ;
return ( @t ) ;
}
