#!/usr/bin/perl -w
# use strict;
#$my $test_key = 'Malhotra et al., 1998' ;
#print ">$test_key<\n" ;
print " @ARGV \n" ;
my %commands = () ;
my $in_file = "lit.txt" ;
my $lit_form = "etal" ;
my $out_file = "script.txt";
my $txt_form = "etal" ;
my $out_style = "alpha" ;

(%commands) = get_commands ( @ARGV ) ;
if ( scalar(@ARGV) <= 0 ) { push ( @{$commands{'help'}}, ' ' ) ; } 
my $i = 0 ; my $keyword ; 
foreach $keyword ( sort keys (%commands) ) 
{
    $i++ ; 
    print "$i.) >$keyword<:  @{$commands{$keyword}}\n";
    if ( $keyword eq 'i' || substr($keyword, 0,2) eq "in"  ) { goto IN }
    if ( $keyword eq 'o' || substr($keyword, 0,3) eq "out"  ) { goto OUT }
    print "REF_MAN: unknown keyword >$keyword<\n" ;
    next ;
    
  HELP:
    print" -i/--in     input file >$in_file< \n" ;
    print" -o/--out    output file >$out_file< \n" ;
    exit ;
  IN: 
	$in_file = shift ( @{$commands{$keyword}} ) ; 
	next ;
  OUT: 
	$out_file = shift ( @{$commands{$keyword}} ) ; 

	next ;
}
 print " text: >$out_file< lit: >$in_file< style: >$out_style< \n" ;
my @paper = read_para_file ( $in_file ) ;
write_file ( $out_file, @paper ) ;

exit ;

sub read_para_file 
{  
    my $file_name = $_[0] ; my $new_line ; 
    my @in_line = () ;
    my @to_line = () ;
    my $prg = '' ;
    my @parag = () ;
    my $np_line = 0; 
    my @whole_file = () ;
    my $n_label ; my $n_targ ; my $I ;
    my $lab ; 
    my $lab_in ;
    my $line ; my $chr_test ;
    open ( TXT, $file_name ) || die "FILE OPEN ERROR: >$file_name< \n" ; 
#    print " read para_file: >$file_name<\n" ;
    my $nc ;

while(<TXT>)
{
    chomp ;
    $line = $_ ;
    $nc = length($line) ;
    $np_line++;
#    print "$np_line)", $line,"\n" ;
#    $new_line = "" ;
    $n_label = 0 ;
    $lab = "OK" ;
    $lab_in = "FALSE" ;
    @in_line = () ;
    $new_line = "" ;
    if ( $nc > 0 ) 
    {
	@in_line = split ('', $line ) ; @to_line = () ;
	if ( lc($in_line[0]) eq 'c' || $in_line[0] eq '!' ) 
	{ 
	    $in_line[0] = '!' ; 
	    $new_line = join ( '', @in_line ) ;
#	    print $nc, " >", $n_label, " comment \n" ;
#	    print " in coomment:", $new_line, "\n" ;
	}
	elsif ( lc($in_line[0]) eq '#' ) 
	{ 
	    $new_line = join ( '', @in_line ) ;
	    if ( $new_line =~ "include" ) 
	    { 
		if ( $new_line =~ "common" )
		{ $new_line =~ s/common/COMMON/; }
		elsif ( $new_line =~ "fcm" ) 
		{
		    if ( $new_line =~ "graph/" )
		    {$new_line =~ s/\"graph\//\"graph\/COMMON\//; }
		    else
		    {$new_line =~ s/\"/\"COMMON\//; }
		}
	    }
	    if ( $new_line =~ "ifdef" ) 
	    { $new_line =~ s/FOR90/FORTRAN_95/; }

#	    print "$nc: $n_label CPP \n" ;
	}
	else
	{
#	    print "$nc: $n_label REST \n" ;
	    $n_targ = 0 ;
	    while ($n_label <= 8 && $n_label < $nc ) 
	    {
#		print $nc, " >>", $n_label, " nlabel: \n" ;
		$chr_test = $in_line[$n_label] ;
#		print $nc, " >>", $n_label, " nlabel:", $chr_test, " \n" ;
		if (  ( $lab eq "OK") && ( $chr_test ge '0') &&  ($chr_test le '9') )
#		if (  $lab eq "OK" )
		{
		    $n_targ++ ; push ( @to_line, $chr_test ) ;
#		    print " $nc.) > nm $n_label ${$in_line[$n_label]} \n" ;
		    $lab_in = "TRUE" ;
		    if ( $n_label == 6 ) 
		    {
#			print " 6 CONTINUATION" ;
			$lab = "NOT" ; 
		    }
		}
		elsif ( $chr_test ge ' ' ) 
		{
#		    print " $nc.) > ch $n_label ", $chr_test, " \n" ;
		    $n_targ++ ; push ( @to_line, $chr_test ) ;
		    if ( $lab_in eq "TRUE" ) { $lab = "NOT" ; }
		} 
		elsif ( $chr_test eq "\t" ) 
#		if ( $line =~ '\t' ) 
		{
		    if ( $lab_in eq "TRUE" ) { $lab = "NOT" ; }
		    for ( $I = $n_label ; $I < 7 ; $I++ ) 
		    { 
			$n_targ++ ; push ( @to_line, " " ) ;
		    }
		    $chr_test = $in_line[1] ;
		    if ( $nc > 1 )
		    {
			if ( $n_label <= 1 && $chr_test ge '0' &&  $chr_test le '9')
#		    if ( $chr_test ge '0' &&  $chr_test le '9')
			 {
#			     print " $nc.) > continueation  $n_label $chr_test \n" ;
			     $to_line[5] = "&" ;
			     $n_label++ ;
			 }
		    }
#		    print " $nc.) > TAB  $n_label \n" ;
#		    $n_label = 8 ;
		}
		$n_label++ ;
	    }
	    for ( $I = $n_label ; $I < $nc ; $I++ ) 
	    { 
		if ( $I > 2 && $in_line[$I] ne "\t" ) 
		{ 
		    push( @to_line, $in_line[$I] ) ; 
		} 
	    }
	    $new_line = join ( '', @to_line ) ;
	}
	
    }

#    print "$np_line>", $new_line, "\n" ;
    push ( @whole_file, $new_line );

}

    print " read para_file:done  >$file_name< records: $np_line\n" ;
close ( TXT ) ;
return ( @whole_file ) ;
}

sub write_file
{
    use FileHandle ;
    my $file_name = shift ; 
    my @text_file = @_ ;

    open( TXT, ">$file_name" )  || die ; 
#    my $TXT = new FileHandle ( "> $file_name" )  || die ; 
    my $prg ;
    foreach $prg ( @text_file ) 
    {
	print TXT $prg, "\n" ;
    }
    close (TXT) ;
}


sub get_commands
{
    my $key = "" ;
    my $word ;
    my %c_line = () ;
    my @arg_char = () ;
    foreach $word ( @_ )
    {
	@arg_char = split( '', $word ) ;
#	print "word: $word \n" ; 
	if ( length($word) <= 0 ) { next ; }
	if ( $word !~ m"[a-zA-F]" ) { } #print "word: $word is a number\n" ; }
	else 
	{ 
#	    print "word: $word is a NON-number\n" ; 

	    if ( $arg_char[0] eq '-' ) 
	    {
		if ( $arg_char[1] eq "-" ) 
		{
		    my $num = scalar(@arg_char) - 1;
		    $key = join ( "", @arg_char[2 .. $num] );
		    push ( @{$c_line{$key}}, ' ' ) ; 
		}
		else
		{
		    $key = $arg_char[1] ; 
		    push ( @{$c_line{$key}}, ' ' ) ; 
		}
		next ;
	    }
	}

	if ( $key ne '' ) 
	{ 
	    $key = lc ( $key ) ; 
#	print "$key: \n" ;
	    my $tmp = join ( '', @{$c_line{$key}} ) ; 
	    if ( $tmp eq ' ' ) { delete $c_line{$key} ; }
	    push ( @{$c_line{$key}}, $word ); 
	}
    }
    return ( %c_line ) ;
}

